// CC-006 - Ghost Shrine
//
// This is coded fast, loose, and unsafe as hell.
// For the love of god, don't code a real game like this, okay?
//
#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "raylib.h"


#define MIN(a,b) (((a)<(b))?(a):(b))
#define MAX(a,b) (((a)>(b))?(a):(b))

#define SCREEN_W          1280
#define SCREEN_H           960
#define GLSL_VERSION       330

#define MAX_ACTORS         768
#define MAX_TEXTBOX          8
#define MAX_ANIMATIONS       4
#define MAX_FRAMES          16
#define MAX_SFX             32

#define PURE_GREEN       (Color){   0, 255,   0, 255 }
#define PURE_BLUE        (Color){   0,   0, 255, 255 }
#define PURE_YELLOW      (Color){ 255, 255,   0, 255 }
#define SCORE_PINK       (Color){ 242, 103, 119, 255 }
#define SCORE_ORANGE     (Color){ 255, 161,   0, 255 }
#define WATER            (Color){  25, 113, 180, 255 }
#define SCORE_GREEN      (Color){ 145, 240,   0, 255 }
#define SKY_BLUE         (Color){  25, 113, 180, 255 }

#define EYE_ORANGE       (Color){ 215, 115,   0, 255 }
#define CHILL_CYAN       (Color){  22, 230, 255, 255 }


#define SESSION_TIME     10800
#define MOVE_SCALE        4.00
#define TILE_SIZE        16.00
#define ACTOR_SCALE       4.00

#define GRAVITY_PULL      0.10
#define MAX_LAMPS         8
#define MAX_OSCILLATORS   4





// Update routines (should be called per-frame, or at fixed intervals)
// Project-specific routines are listed last
//
void check_textbox();
void check_animations();
void check_shaders();
void check_time();
void check_score();
void check_actors();
void check_input();
void check_sfx_buffer();

void check_oscillators();

void cleanup();
void end_game();
void show_stats();


// Spawning and actor maintenance routines
//
void kill_actor(int slot);
void spawn_permanent_actors();
int  spawn_moon();
int  spawn_actor(int type, float x, float y, float z, int cell_x, float path_x, float path_y, float path_z);
int  spawn_bullet(float x, float y, float z, int type);
int  spawn_shrine(int x, int y);
int  spawn_lantern(int x, int y, int z_offset);
int  spawn_brush(int x, int y, Color col, float scale);
int  spawn_ghost(int x, int y, int z);
int  spawn_trail(int ball);
int  spawn_shield_ball(int lamp);
int  spawn_fireball(float x, float y, float z, int dir);
int  spawn_frostball(float x, float y, float z, int dir);
int  spawn_vortex(float x, float y, float z);
int  spawn_dragon(float y, float z, int dir);
int  spawn_wind(float y, float z, int dir);
int  spawn_terminal(float x, float y, float z);
int  spawn_ouroborus(float x, float y, float z);

void damage_lantern(int who, int amount);

void assign_animation(int who, int anim, int loops);
void kill_animation(int who);



// Drawing routines
//
void draw_actor(int slot);
void blend_helper_ex(Texture2D source,  Vector2 dest, float angle, float scale, Color tint);
void blend_helper(Texture2D source, Rectangle rect_s, Rectangle rect_d, Vector2 origin, float angle, Color tint);
void draw_summary();
void draw_tutorial();
void draw_high_score();
void draw_title_hud();
void draw_title();
void draw_hud();
void draw_signal(int signal);
Color FR_grab_gradient(Color c1, Color c2, float banding, float zero_to_one);


// Misc project-specific nonsense
//
void moon_shot(int slot);
void display_signal(int type);
void buffer_sfx(int sfx_slot, int ticks);


void draw_text_box(int slot);
void trigger_textbox(int slot, int x, int y, int w, int h, int message, int delay, int duration);

void update_and_render();
void render_frame(int mode);    // Standard rendering

void init_game_variables();

int  get_free_actor();
int  get_population(int team);
int  get_initial();

int  check_floats(float one, float two, float range);                // Checks if two floats are within [range]
int  check_collision(int who, int target, int radius, int z_adjust); // Checks a single target for distance overlap





// Old Framework stuff here
int sorted[MAX_ACTORS][2];

void FR_merge_actors();
void FR_prep_for_sort();
void FR_quicksort(int low, int high);
void FR_swap_int(int n1, int n2, int index);
int  FR_2d_dist(int x1, int y1, int x2, int y2);
float scale(float value, float source_min, float source_max, float scaled_min, float scaled_max);
float norm_f(float source, float min, float max);
bool valid_actor(int who);
// End nonsense


// Wrapping nonsense
void blit(Image src, Image dest, int s_x, int s_y, int d_x, int d_y, int w, int h);
void blit_v(Image src, Image dest, int s_x, int s_y, int d_x, int d_y, int w, int h);
void blit_h(Image src, Image dest, int s_x, int s_y, int d_x, int d_y, int w, int h);
void push_rect(Rectangle *rect, float x, float y, float w, float h);



// Important actor tracking vars
//
int puppet        = -1; // Actor being controlled by the player
int shrine        = -1; // Shrine's actor
int moon          = -1; // Moon's actor
int population[2] = { 0, 0 };
int lamps[MAX_LAMPS];


char custom_text[80];
float screenSize[2];

double rad_conv = (PI / 180);

int calculate     = 0;  // Defers calculations for so many frames
int tutorial_seen = 0;
int game_over     = 0;  // Triggers end of game (0 = game active. 1 = summary. 2 = high score)
int total_actors  = 0;  // Debugging var


int select        = 0;  // Current player's menu selection
int accept        = 0;  // Current player's prompt selection
int yes_no        = 0;  // shows prompt when > 0



int high_score    = 666;
unsigned char high_init[4] = { 71, 68, 82, 0 };

int slow_time     = 0;            // > 0 if time is slowed by player
int slow_frame    = 0;            // Current number of updates skipped by slowdown

int box_tex_x   = 0;              // For anchoring happy texture at game over summary
int box_tex_y   = 0;              //
int box_update  = 0;              //

int water_tex_x   = 0;            // For anchoring happy texture at game over summary
int water_tex_y   = 0;            //
int water_update  = 0;            //

int clock_min     = 0;            // Countdown readout
int clock_sec     = 0;            //
int clock_sub     = 0;            //

int score         = 0;            // Your score
int score_diff    = 0;            // Score differential. Positive values add, negative subtract.
int score_shake   = 0;            // Number of frames to "shake" score display. Used for negative hits.
int score_ticks   = 0;            // User for score tracking

int quake_ticks    = 1800;        // Frames before next quake
int quake_base     = 3600;        // Base ticks
int quake_spread   = 1800;        // Randomness to quakes
int quake_duration = 0;           // Quake frames left to animation

int game_ticks    = SESSION_TIME; // Number of clock ticks left in game (60 = 1 second)
int frame_ticks   = 0;            // Used for end game animations
int show_signal   = -1;           // Shows ball or strike indicator on screen
int swung         = 0;            // > 0 if current pitch has been swung at
int swing_active  = 0;            // Are we swinging the bat?
int swing_angle   = 0;            // What angle did we commit to?
int sfx_buffer[16][2];            // Allows buffering of sounds (up to 16, by clock ticks)

int game_mode     = 0; // 0 = title.    1 = Tutorial.     2 = game.    3 = Game Over.     4 = Credits?
float anims[16]   = { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 };
float t_angle[4]  = { 0.0, 0.0, 0.0, 0.0 };
float t_offset[4] = { 0.0, 90.0, 180.0, 270.0 };
float charge_time[4] = { 3000, 4000, 4000, 2500 }; // Ouroborus, Terminal, Dragon, Wind




Camera2D camera      = { 0 };
Vector2 cam_velocity = { 0, 0 };

Vector2 mouse        = { 0, 0 };
Vector2 mouse_cam    = { 0, 0 };

Texture2D tex_title;
Texture2D tex_tiles[5];
Texture2D tex_emoji;
Texture2D tex_moon;
Texture2D tex_stars;
Texture2D tex_eye_l;
Texture2D tex_eye_r;
Texture2D tex_fire;
Texture2D tex_brush;
Texture2D tex_wind;
Texture2D tex_x;
Texture2D tex_dragon;
Texture2D tex_terminal;
Texture2D tex_ouroborus;
Texture2D tex_shrine;
Texture2D tex_sparkle;
Texture2D tex_ball[28];

Texture2D tex_background;
Texture2D tex_16x;
Texture2D tex_32x;
Texture2D tex_64x;
Texture2D box_tex;

Sound sfx[MAX_SFX];

Font font1;         // Bubble font
Font font3;         // 3x5 font

RenderTexture2D target;       // For full-screen shader handling


// Shader crap here (plz move this into something sane FFS)
//
Shader wave;
float s_vars[6] = { 4.0, 0.0, 4.0, 0.0, 2.0, 0.0 };     // Brush sine wave
float l_vars[6] = { 20.0, 0.0, 2.0, 0.0, 18.0, 0.0 };   // Lamp sine wave
float f_vars[6] = { 10.0, 10.0, 4.0, 4.0, 18.0, 18.0 }; // Fire sine wave
int secondsLoc = 0;
int freqXLoc   = 0;
int freqYLoc   = 0;
int ampXLoc    = 0;
int ampYLoc    = 0;
int speedXLoc  = 0;
int speedYLoc  = 0;

int loc_time     = 0;
int loc_strength = 0;
float seconds = 0.0f;
float strength = 0.0005f;




// Game-specific flags. Can wipe between projects
//
struct flags_struct
{
 bool invulnerable;           // Makes lanterns immune to all damage
 int frozen_salvo;            // Makes shots "frozen" with no roll and less speed
 int drunken_salvo;           // Makes shots "drunk" with extra roll
 int charge[4];               // Tile charge. Counts down to zero. Zero = full charge
 int selected;                // Player has selected a fully charged tile. Activate when 'Z' released
};

flags_struct flags;





// Shot oscillators
//
struct osc_struct
{
 float angle;
 float roll;
 float cur_time;
 float max_time;
 int shot_queue;
 int shot_type;
};

osc_struct oscillators[MAX_OSCILLATORS];






struct textbox_struct
{
 Rectangle pos;
 float scale;
 bool enabled;                // TRUE if this box is active
 int viewable_text;           // Number of chars currently exposed (starts at zero, counts up)
 int duration;                // Number of ticks before textbox closes. -1 if disabled
 int mode;                    // 0 = entering, 1 = displaying text, 2 = exiting
 int ticks;                   // Counts time between displaying characters
 const char *msg;
};

textbox_struct textbox[MAX_TEXTBOX];





struct anim_struct
{
 int frame_x[MAX_FRAMES];     // x cell of frame inside sprite sheet (cell, not pixel)
 int frame_y[MAX_FRAMES];     // y cell of frame inside sprite sheet
 int timing[MAX_FRAMES];      // timing in game "ticks" to get to next frame
 int total_frames;            // maximum number of frames in this sequence
};

anim_struct anim[MAX_ANIMATIONS];





struct actor_struct
{
 Texture2D cel;         // Pointer to source texture
 Vector3 pos;           // Position
 Vector3 offset;        // Destination (only used to move enemies around)
 Vector3 dest;          // Destination (only used to move enemies around)
 Vector3 path;          // (OPTIONAL) Path of travel (x/y/z)
 Color color;           // Color tint (WHITE by default)

 float blend;           // Blend strength (0-1)    < only applies if not solid >
 float angle;           // Angle of rotation (0-360)
 float v_angle;         // (OPTIONAL) Angle of movement (0-360)
 float v_speed;         // (OPTIONAL) Velocity of movement (tied to v_angle)
 float v_roll;          // (OPTIONAL) != 0 if actor rolls while in flight

 float scale;           // Actor scale (populated during projection)
 float roll;            // != 0 if actor's sprite rolls in place
 float y_shift;         // Dirty hack to physically shift a sprite on y axis by ? pixels (pre-projection)

 float quake;           // > 0 if actor is rolling from damage
 float sinking;         // > 0 if actor is sinking into the sand
 float speed;           // Actor's base speed (0.0 to 0.20) which is added to their movement each turn

 int team;              // 1 = Rack    2 = Baseball    3 = Bags, etc
 int shadow;            // > -1 if an actor is their shadow
 int _size_w;           // Dimensions of the cel frame
 int _size_h;           // Dimensions of the cel frame
 int flip;              // Force horizontal mirroring
 int anim_set;          // Animation set to reference
 int anim_step;         // Which step in the anim sequence we're at
 int anim_timing;       // Current step timing for animation
 int anim_loop;         // # of times to loop animation. 0 if only played once
 int mode;              // 0 = solid. 1 = alpha
 int state;             // 0 = inactive. 1-12 = doing stuff
 int effect;            // 0 = none.
 int home;              // Rack that owns this object
 int timer;             // Internal timer for animation purposes, or whatever you need
 int stamina;           // Walking and being attacked drain stamina. When <= 0 the actor dies or fades out
 int cel_x;             // X cel within sprite sheet
 int cel_y;             // Y cel within sprite sheet
 int locked_to;         // Actor this player was triggered by (so ammo doesn't hit the actor firing it!)
 int extra;             // Extra data point for use wherever (lazy!)
 int event;             // > 0 if actor will trigger an event when their commitment has ended

 float scale_ramp;      // Maximum value scale additive will ramp to
 float scale_mod;       // Modifies scale variable, when rendering sprite. This is a factor.
 float scale_up;        // Speed of scale ramping
 float scale_down;      // Speed of scale ramping

 int updates;           // Number of movement updates per -tick (default is 1)
 int moved_up;          // > 0 if actor has moved up recently
 int moved_down;        // > 0 if actor has moved down recently
 int moved_wait;        // > 0 if actor needs to wait before heading to next way-point

 int d_pad[4];          // Janky virtual gamepad (refine later)
 int buttons[4];        //

 int shader;            // > 0 if a shader is in use with this actor
 float s_vars[10];      // Storage space for shader vars. These will vary according to the shader in use

 bool decal;            // Indicates actor is a floor decal, and will be drawn before normal actors
 bool flicker;          // Tracks actor flicker (used by effects)
 bool mirror;           // TRUE if actor is mirrored on X-axis
 bool gravity;          // TRUE if gravity affects Y coordinate
 bool projected;        // TRUE is actor is passed through projection stage before drawing
 bool enabled;          // TRUE if this actor is active
 bool visible;          // TRUE if this actor will be drawn to screen
 bool accessory;        // TRUE if actor will be rendered with a package object
                        // and should not be drawn or interacted with otherwise
};

actor_struct actors[MAX_ACTORS];





// I got tired of making everything global. Fuck me.
//
struct hi_struct
{
 int selected;                // Character currently selected (0-2 valid)
 unsigned char initials[3];   // Stores characters entered by user
 int blink;                   // True if we can display blinking chars
 int blink_timer;             // Timer to track above variable
};

hi_struct hi_score;




bool SKIP_INTRO = 0;          // TRUE if we want to skip the title screen and tutorial
float debug[10] = { 0.0, 0.0, 0.0, 0.0, 0.0,   0.0, 0.0, 0.0, 0.0, 0.0 };




float shot_vars[5][4] = { // cell, roll, speed, etc
 0.0, 0.0, 0.0, 0.0,      // 00 Don't use
 3.0, -0.25, 4.0, 0.0,    // 01 Red
 4.0, -0.25, 3.0, 0.0,    // 02 Heavy shot
 5.0, 0.40, 5.0, 0.0,     // 03 ?
 6.0, 0.10, 2.5, 0.0      // 04 Yellow
};



const char *state_string[] = {
 /* 00 */ ".",
 /* 01 */ ".",
 /* 02 */ ".",
 /* 03 */ ".",
 /* 04 */ ".",
 /* 05 */ ".",
 /* 06 */ ".",
 /* 07 */ ".",
 /* 08 */ ".",
 /* 09 */ ".",
 /* 10 */ ".",
 /* 11 */ ".",
 /* 12 */ ".",
 /* 13 */ ".",
 /* 14 */ ".",
 /* 15 */ ".",
 /* 16 */ ".",
 /* 17 */ ".",
 /* 18 */ "."
};






int main(void)
{
 int i    = 0;
 int k    = 0;
 int next = 0;
 int exit = 0;
 char rep_str[37];
 char name[256];


    // Init OpenGL, etc
    //
    //SetConfigFlags(FLAG_WINDOW_UNDECORATED);
    InitWindow(SCREEN_W, SCREEN_H, "CC-006 - Ghost Shrine");
    InitAudioDevice();

    SetTargetFPS(60);
    HideCursor();


    screenSize[0] = (float)GetScreenWidth();
    screenSize[1] = (float)GetScreenHeight();


    target = LoadRenderTexture(SCREEN_W, SCREEN_H);

    // Load textures
    //
    tex_emoji        = LoadTexture("gfx/tex_emoji.png");
    tex_tiles[0]     = LoadTexture("gfx/tex_tiles_0.png");
    tex_tiles[1]     = LoadTexture("gfx/tex_tiles_1.png");
    tex_tiles[2]     = LoadTexture("gfx/tex_tiles_2.png");
    tex_tiles[3]     = LoadTexture("gfx/tex_tiles_3.png");
    tex_tiles[4]     = LoadTexture("gfx/tex_tiles_4.png");
    tex_title        = LoadTexture("gfx/tex_title.png");
    tex_background   = LoadTexture("gfx/tex_background.png");
    tex_moon         = LoadTexture("gfx/tex_moon_new.png");
    tex_stars        = LoadTexture("gfx/tex_stars.png");
    tex_eye_l        = LoadTexture("gfx/tex_eye_small.png");
    tex_fire         = LoadTexture("gfx/tex_fire.png");
    tex_brush        = LoadTexture("gfx/tex_brush.png");
    tex_x            = LoadTexture("gfx/tex_x.png");
    tex_wind         = LoadTexture("gfx/tex_wind.png");
    tex_dragon       = LoadTexture("gfx/tex_dragon.png");
    tex_terminal     = LoadTexture("gfx/tex_terminal.png");
    tex_ouroborus    = LoadTexture("gfx/tex_ouroborus.png");
    tex_shrine       = LoadTexture("gfx/tex_shrine.png");
    tex_sparkle      = LoadTexture("gfx/tex_sparkle.png");

    tex_16x          = LoadTexture("gfx/tex_16x.png");
    tex_32x          = LoadTexture("gfx/tex_32x.png");
    tex_64x          = LoadTexture("gfx/tex_64x.png");
    box_tex          = LoadTexture("gfx/box_tex.png");

    // Load the "ball"  (My laziness has reached a new level)
    //
    for(i=0; i<28; i++) {
        memset(&name[0], 0, 256);
        sprintf(&name[0], "gfx/ball/tex_ball_%02d.png", i);
        tex_ball[i] = LoadTexture(name);
                        }

    // Right Eye gets loaded as an image, then flipped to create an alt texture.
    // I'm lazy and just want to blit with a scale, which precludes flipping
    //
    Image temp = LoadImage("gfx/tex_eye_small.png");
    ImageFlipHorizontal(&temp);
    tex_eye_r = LoadTextureFromImage(temp);
    UnloadImage(temp);


    // Custom font loading
    //
    font1 = LoadFont("gfx/16x_bubble.png");
    font3 = LoadFont("gfx/3x_square.png");


    // Shader crap
    //
    wave       = LoadShader(0, "SHADERS/wave.fs");
    secondsLoc = GetShaderLocation(wave, "secondes");
    freqXLoc   = GetShaderLocation(wave, "freqX");
    freqYLoc   = GetShaderLocation(wave, "freqY");
    ampXLoc    = GetShaderLocation(wave, "ampX");
    ampYLoc    = GetShaderLocation(wave, "ampY");
    speedXLoc  = GetShaderLocation(wave, "speedX");
    speedYLoc  = GetShaderLocation(wave, "speedY");

    SetShaderValue(wave,   GetShaderLocation(wave, "size"), &screenSize, SHADER_UNIFORM_VEC2);


    // Load sound effects
    //
    sfx[2]  = LoadSound("sfx/002.wav"); // OK GUI beep
    sfx[3]  = LoadSound("sfx/003.wav"); // Wrong/NOPE GUI beep




    // Set sound effect attributes
    //
    SetSoundVolume(sfx[2], 0.25);
    SetSoundPitch(sfx[2],  1.00);

    SetSoundVolume(sfx[3], 0.25);
    SetSoundPitch(sfx[3],  1.00);



    // We will call this routine to clean up on program exit
    //
    atexit(cleanup);


    // We will land here after a successful game loop
    //
    restart:


    init_game_variables();




    if(SKIP_INTRO) { goto skip_jank; }


    /// Title block loop ---------------------------------------------------------------------------------------
    //
    do {
        anims[0] = 1.00;
        update_and_render();

///        anims[15] += 0.05;
///        if(anims[15] >= 360.00) { anims[15] -= 360.00; }

        if(IsKeyDown(KEY_Z)) { next = 1; }
        if(next && (!IsKeyDown(KEY_Z))) { PlaySound(sfx[2]); exit = 1; }

       } while (!exit);



    // Fade Title out
    //
    do {
        anims[0] -= 0.025;
        update_and_render();
       } while (anims[0] > 0.00);



    /// Tutorial Loop ------------------------------------------------------------------------------------------
    //
    if(!tutorial_seen) {
        // Tutorial Display loop (only on first game of each session)
        //
        next      = 0;
        exit      = 0;
        game_mode = 1;

        do {
            update_and_render();

            if(IsKeyDown(KEY_Z)) { next = 1; }
            if(next && (!IsKeyDown(KEY_Z))) { PlaySound(sfx[2]); exit = 1; }

           } while (!exit);


        // Fade Title out
        //
        do {
            anims[1] -= 0.04;
            update_and_render();
           } while (anims[1] > 0.00);

        tutorial_seen = 1;
                       }



    skip_jank:

    /// Main Game Loop -----------------------------------------------------------------------------------------
    //
    next      = 0;
    exit      = 0;
    game_mode = 2;



    while (!game_over) { update_and_render(); }


    // End game summary and high score
    //
    end_game();

    goto restart;

    return(0);
}





// This routine is automatically called at program exit
//
void cleanup()
{
 int i = 0;

 // Free resources and clean up
 //
 UnloadTexture(tex_emoji);
 UnloadTexture(tex_tiles[0]);
 UnloadTexture(tex_tiles[1]);
 UnloadTexture(tex_tiles[2]);
 UnloadTexture(tex_tiles[3]);
 UnloadTexture(tex_tiles[4]);

 UnloadTexture(tex_title);
 UnloadTexture(tex_background);
 UnloadTexture(tex_16x);
 UnloadTexture(tex_32x);
 UnloadTexture(box_tex);


 UnloadFont(font1);
 UnloadFont(font3);

 UnloadSound(sfx[2]);
 UnloadSound(sfx[3]);

 CloseWindow();                // Close window and OpenGL context

 return;
}






// Performs logic update and calls rendering stuff
//
void update_and_render()
{
 int moved      = 0;
 int stride     = 0;
 int i          = 0;
 float rotation = 0.0;
 float offset   = 0.0;

 total_actors   = 0;


 if(WindowShouldClose()) { exit(0); }


 check_shaders();
 check_animations();
 check_textbox();
 check_actors();


 if(!game_over && game_mode > 1) {
     check_oscillators();
     check_sfx_buffer();
     check_input();
     check_score();

     if(!slow_time || (slow_time && slow_frame > 3)) {
         check_time();
         slow_frame = 0;
                                                     }
     else { slow_frame++; }
                                 }

 render_frame(game_mode);

 return;
}







void render_frame(int mode)
{
 int i    = 0;
 int j    = 0;
 int k    = 0;
 int t_x  = 0;
 int t_y  = 0;
 int tile = 0;

 Vector2 dest = { 0 };
 Color col = BLANK;
 Color brush_start = (Color){  35,  23, 11, 255 };
 Color brush_end   = (Color){ 188, 126, 60, 255 };

 float quake_scale = 0.0;
 float mouse_scale = 1.0;
 float offset      = 0.0;
 float angle       = 0.0;
 float y_scale     = 0.5;
 float scale       = 1.0;
 float x_shift     = 0.0;
 float fade        = 1.0;



 if(quake_duration) {
     quake_scale = 30.0 * ((float)quake_duration / 180.00);
     camera.offset.x += GetRandomValue(-quake_scale, quake_scale);
     camera.offset.y += GetRandomValue(-quake_scale, quake_scale);
     quake_duration--;
                    }
 else {
     camera.offset.x = (float)SCREEN_W / 2.0f;
     camera.offset.y = (float)SCREEN_H / 2.0f;
      }


 BeginDrawing();
 BeginMode2D(camera);


 /// Composition order is: Stars, Moon, Eyes, actors (brush strips are actors and will self-sort)
 ///
 DrawTextureEx(tex_stars, (Vector2){0, -600}, 0.0, 1.0, WHITE);


 // Draw moon and eyes
 //
 dest.x = actors[moon].pos.x;
 dest.y = actors[moon].pos.y;
 DrawTextureEx(tex_moon, dest, 0.0, 1.0, WHITE);

 dest.x = actors[moon].pos.x + 300;
 dest.y = actors[moon].pos.y + 350;
 blend_helper_ex(tex_eye_l,  dest, 0.0, 0.50, Fade(EYE_ORANGE, 0.25));

 dest.x = actors[moon].pos.x + 450;
 dest.y = actors[moon].pos.y + 350;
 blend_helper_ex(tex_eye_r,  dest, 0.0, 0.50, Fade(EYE_ORANGE, 0.25));


 // Draw "Ground"
 //
 DrawRectangleGradientV(0, SCREEN_H - 300, SCREEN_W, 300, brush_start, brush_end);


 // Sort actors
 //
 FR_prep_for_sort();
 FR_quicksort(0,(MAX_ACTORS-1));
 FR_merge_actors();


 // Draw Tiles, if player has menu open
 //
 int adjust = actors[puppet].pos.z - 40;
 if(IsKeyDown(KEY_Z) && game_mode == 2) {

     /// (UP) - Ouroborus
     dest.x = actors[puppet].pos.x - 58;
     dest.y = actors[puppet].pos.y - adjust - 275;
     if(!flags.charge[0]) { tile = 3; }
     else                 { tile = 0; }

     if(!flags.charge[0] && flags.selected == 0) { col = GREEN; fade = 0.25 + (anims[3] * 0.75); }
     else                                        { col = WHITE; fade = 1.00;                     }
     DrawTextureEx(tex_tiles[tile],  dest, 0.0, 1.0, Fade(col, fade));

     /// (LEFT) - Dragon
     dest.x = actors[puppet].pos.x - 154;
     dest.y = actors[puppet].pos.y - adjust - 152;
     if(!flags.charge[2]) { tile = 1; }
     else                 { tile = 0; }

     if(!flags.charge[2] && flags.selected == 2) { col = PINK; fade = 0.25 + (anims[3] * 0.75); }
     else                                        { col = WHITE; fade = 1.00;                    }
     DrawTextureEx(tex_tiles[tile],  dest, 0.0, 1.0, Fade(col, fade));

     /// (RIGHT) - Wind
     dest.x = actors[puppet].pos.x + 36;
     dest.y = actors[puppet].pos.y - adjust - 152;
     if(!flags.charge[3]) { tile = 4; }
     else                 { tile = 0; }

     if(!flags.charge[3] && flags.selected == 3) { col = BLUE; fade = 0.25 + (anims[3] * 0.75); }
     else                                        { col = WHITE; fade = 1.00;                    }
     DrawTextureEx(tex_tiles[tile],  dest, 0.0, 1.0, Fade(col, fade));


     /// (DOWN) - Terminal
     dest.x = actors[puppet].pos.x - 58;
     dest.y = actors[puppet].pos.y - adjust - 32;
     if(!flags.charge[1]) { tile = 2; }
     else                 { tile = 0; }

     if(!flags.charge[1] && flags.selected == 1) { col = ORANGE; fade = 0.25 + (anims[3] * 0.75); }
     else                                        { col = WHITE; fade = 1.00;                      }
     DrawTextureEx(tex_tiles[tile],  dest, 0.0, 1.0, Fade(col, fade));
                                        }

 // If player isn't drawing a tile, display any tiles that are recharging
 //
 else {
     if(flags.charge[0] > 0) { /// Ouroborus
         dest.x = actors[puppet].pos.x - 26;
         dest.y = actors[puppet].pos.y - adjust - 245;
         DrawTextureEx(tex_x,  dest, 0.0, 2.0, Fade(WHITE,norm_f(flags.charge[0], 0, charge_time[0])));
                             }

     if(flags.charge[1] > 0) { /// Terminal
         dest.x = actors[puppet].pos.x - 26;
         dest.y = actors[puppet].pos.y - adjust;
         DrawTextureEx(tex_x,  dest, 0.0, 2.0, Fade(WHITE,norm_f(flags.charge[1], 0, charge_time[1])));
                             }

     if(flags.charge[2] > 0) { /// Dragon
         dest.x = actors[puppet].pos.x - 120;
         dest.y = actors[puppet].pos.y - adjust - 120;
         DrawTextureEx(tex_x,  dest, 0.0, 2.0, Fade(WHITE,norm_f(flags.charge[2], 0, charge_time[2])));
                             }

     if(flags.charge[3] > 0) { /// Wind
         dest.x = actors[puppet].pos.x + 70;
         dest.y = actors[puppet].pos.y - adjust - 120;
         DrawTextureEx(tex_x,  dest, 0.0, 2.0, Fade(WHITE,norm_f(flags.charge[3], 0, charge_time[3])));
                             }

      }


 // Having drawn all the necessary stuff, handle mode-specific overlays
 //
 switch(game_mode) {
     case 0: // Title screen
             draw_title_hud();
             draw_title();
             break;

     case 1: // Introduction / Tutorial
             draw_tutorial();
             break;

     case 2: // In-game
             if(show_signal != -1) { draw_signal(show_signal); }
             break;

     case 3: // Game over / Summary
             draw_summary();
             break;
                   }


 if(!game_over && game_mode > 1) { draw_hud(); }

 EndMode2D();
 EndDrawing();

 return;
}





// NOTE: Typical usage is to put the box over a character or tile's position
//
void draw_text_box(int slot)
{
 Rectangle dest;
 char strang[80];

 Vector2 text_coords;
 Vector2 text_len;


 if(!textbox[slot].enabled) { return; }
 if(textbox[slot].mode < 0) { return; }


 // Calculate textbox dimensions, etc
 //
 dest.width  = textbox[slot].pos.width  * textbox[slot].scale;
 dest.height = textbox[slot].pos.height * textbox[slot].scale;

 dest.x = textbox[slot].pos.x - (dest.width / 2.0f);
 dest.y = textbox[slot].pos.y - (dest.height / 2.0f);


 // Draw border around box
 //
 DrawRectangleLinesEx(dest, 4, WHITE);


 // Draw tiled texture (happy face) and update anchor coordinates
 //
 Rectangle tex_s = { box_tex_x,box_tex_y, 64, 32 };
 Rectangle tex_d = { dest.x+3, dest.y+3, dest.width - 6, dest.height - 6 };
 DrawTextureTiled(box_tex, tex_s, tex_d, (Vector2){0,0}, 0.0, 3.0, Fade(WHITE, 0.90));


 // Measure text and box and figure out how to center text
 //
 text_len = MeasureTextEx(font3, textbox[slot].msg, (font3.baseSize * 2), 1);

 text_coords.x = dest.x + (dest.width / 2) - (text_len.x / 2);
 text_coords.y = dest.y + (dest.height / 2.0f) - font3.baseSize;


 // Draw characters
 //
 if(textbox[slot].viewable_text > 0) {
     memset(strang, 0, sizeof(strang));
     strncpy(strang, textbox[slot].msg, textbox[slot].viewable_text);
     DrawTextEx(font3, strang, text_coords, (font3.baseSize * 2), 1, WHITE);
                                     }

 return;
}





void draw_high_score()
{

 return;
}




// NOTE: Checks player input for activity
//
void check_input()
{
 float player_speed = 4.0;


 if(IsKeyDown(KEY_Z)) {
     if(IsKeyDown(KEY_UP))    { if(!flags.charge[0]) { flags.selected = 0; } }
     if(IsKeyDown(KEY_DOWN))  { if(!flags.charge[1]) { flags.selected = 1; } }
     if(IsKeyDown(KEY_LEFT))  { if(!flags.charge[2]) { flags.selected = 2; } }
     if(IsKeyDown(KEY_RIGHT)) { if(!flags.charge[3]) { flags.selected = 3; } }
                      }

 else {

     if(flags.selected != -1) {
         switch(flags.selected) {
             case 0: // Ouroborus
                     spawn_ouroborus(actors[puppet].pos.x, actors[puppet].pos.y - 2, actors[puppet].pos.z - 1000);
                     flags.charge[0] = charge_time[0];
                     break;

             case 1: // Terminal
                     spawn_terminal(SCREEN_W / 2.0, actors[puppet].pos.y - 4, actors[puppet].pos.z + 800);
                     flags.charge[1] = charge_time[1];
                     break;

             case 2: // Dragon
                     if(actors[puppet].pos.x < (SCREEN_W / 2.0)) { spawn_dragon(actors[puppet].pos.y - 8, 0, 0); }
                     else                                        { spawn_dragon(actors[puppet].pos.y - 8, 0, 1); }
                     flags.charge[2] = charge_time[2];
                     break;

             case 3: // Wind
                     if(actors[puppet].pos.x < (SCREEN_W / 2.0)) { spawn_wind(actors[puppet].pos.y - 10, -200, 0); }
                     else                                        { spawn_wind(actors[puppet].pos.y - 10, -200, 1); }
                     flags.charge[3] = charge_time[3];
                     break;
                                }

                              }

     flags.selected = -1;


     // For this project, player can only move left or right
     // and only if they aren't selecting a summon tile
     //
     if(IsKeyDown(KEY_LEFT)) {
         actors[puppet].flip = 1;
         if(actors[puppet].pos.x > 100) { actors[puppet].pos.x -= player_speed; }
                             }

     if(IsKeyDown(KEY_RIGHT)) {
         actors[puppet].flip = 0;
         if(actors[puppet].pos.x < (SCREEN_W - 100)) { actors[puppet].pos.x += player_speed; }
                              }

      }

 /// DIRTY HACK
 /// Make player sprite bob (it's a fucking ghost, aye?)
 actors[puppet].pos.z += (sin(anims[2] * (PI / 180.0)) * 0.25);


 return;
}




void check_sfx_buffer()
{
 int i = 0;


 for(i=0; i<16; i++) {
     if(sfx_buffer[i][0] != -1) {
         sfx_buffer[i][1]--;

         if(sfx_buffer[i][1] <= 0) {
             PlaySound(sfx[sfx_buffer[i][0]]);
             sfx_buffer[i][0] = -1;
             sfx_buffer[i][1] = 0;
                                   }

                                }
                     }

 return;
}




void check_textbox()
{
 int i = 0;
 int len = 0;

 for(i=0; i<MAX_TEXTBOX; i++) {
     if(textbox[i].enabled) {
         switch(textbox[i].mode) {
                     break;

             case 0: // Entering
                     textbox[i].scale += 0.075;
                     if(textbox[i].scale >= 1.00) { textbox[i].scale = 1.00; textbox[i].mode++; }
                     break;

             case 1: // Displaying text
                     len = strlen(textbox[i].msg);
                     if(textbox[i].viewable_text < len) {
                         textbox[i].ticks++;
                         if(textbox[i].ticks > 3) { textbox[i].viewable_text++; PlaySound(sfx[5]); textbox[i].ticks = 0; }
                                                        }
                     else { textbox[i].ticks++; } // Keep counting ticks, in case useful

                     if(textbox[i].duration != -1) {
                         if(textbox[i].ticks > textbox[i].duration) { textbox[i].mode = 2; }
                                                   }
                     break;

             case 2: // Exiting
                     textbox[i].viewable_text = 0;
                     textbox[i].scale -= 0.075;
                     if(textbox[i].scale <= 0.00) { textbox[i].scale = 0.00; textbox[i].enabled = 0; }
                     break;
                                 }

         if(textbox[i].mode < 0) { textbox[i].mode++; } // Pause before beginning, effectively

                            }
                              }

 // Update background texture position
 //
 if(!box_update) {
     box_tex_x--;
     box_tex_x &= 0x3F;

     box_tex_y++;
     box_tex_y &= 0x1F;

     box_update = 1;
                   }

 else { box_update = 0; }


 // Update water texture position
 //
 if(water_update > 60) {
     water_tex_x++;
     water_tex_x &= 0xFF;

     water_tex_y = 0;
     water_update = 0;
                   }

 else { water_update++; }

 return;
}






// Adjusts score over time
//
void check_score()
{
 bool alive = 0;
 int factor = 1;
 int total  = 0;
 int i      = 0;


 // For each lantern that is alive, increment score by x
 //
 for(i=0; i<MAX_LAMPS; i++) {
     if(actors[lamps[i]].stamina > 0) { score_diff += 200; alive = 1; }
                            }

 if(!alive) { game_over = 1; return; }

 // Score shakes when bad things happen
 //
 if(score_shake > 0) { score_shake--; }


 // Roll differential into score over time. The larger the difference,
 // the faster we will update the score.
 //
 if(score_diff != 0) {

     total = abs(score_diff);
     if(total > 20)   { factor = 1;  }
     if(total > 50)   { factor = 2;  }
     if(total > 100)  { factor = 4;  }
     if(total > 250)  { factor = 12; }
     if(total > 500)  { factor = 16; }
     if(total > 999)  { factor = 24; }
     if(total > 1999) { factor = 32; }
     if(total > 3999) { factor = 48; }
     if(total > 6999) { factor = 64; }

     if(score_diff > 0) { score += factor; score_diff -= factor; }
     if(score_diff < 0) { score -= factor; score_diff += factor; }
                     }

 // Bounds check
 //
 if(score < 0)        { score = 0;        }
 if(score > 99999999) { score = 99999999; }


 // Increment tile charges, if above zero
 //
 for(i=0; i<4; i++) {
     if(flags.charge[i] > 0) { flags.charge[i]--; }
                    }

 return;
}




void check_oscillators()
{
 int i       = 0;
 int check   = 0;
 float delta = GetFrameTime();

 // If frozen, decrease delta by 1/2
 //
 if(flags.frozen_salvo > 0) { delta *= 0.5; }


 // First pass, update
 //
 for(i=0; i<MAX_OSCILLATORS; i++) {
     oscillators[i].angle += oscillators[i].roll;

     oscillators[i].cur_time += delta;
     if(oscillators[i].cur_time >= oscillators[i].max_time) {
         oscillators[i].cur_time -= oscillators[i].max_time;
         if(oscillators[i].shot_queue > 0 && oscillators[i].shot_type > 0) {
             moon_shot(i);
             oscillators[i].shot_queue--;
                                                                           }
                                                            }

                                  }


 // Second pass, check for ammo reload
 //
 for(i=0; i<MAX_OSCILLATORS; i++) {
     check = GetRandomValue(0, 200);
     if(check < 5 && (check & 1)) { oscillators[i].shot_queue += GetRandomValue(10, 100); }
                                  }

/*
struct osc_struct
{
 float angle;
 float roll;
 float cur_time;
 float max_time;
 int shot_queue;
 int shot_type;
};

osc_struct oscillators[MAX_OSCILLATORS];
*/
 return;
}





void check_shaders()
{

 // Used by *quite* a lot of shaders
 //
 seconds += GetFrameTime();


 // Update wave shader
 //
 SetShaderValue(wave, secondsLoc, &seconds, SHADER_UNIFORM_FLOAT);

 return;
}






void check_animations()
{
 int i = 0;
 int SET = 0;

 for(i=0; i<MAX_ACTORS; i++) {
     if(actors[i].enabled && actors[i].anim_set) {
         SET = actors[i].anim_set;

         actors[i].anim_timing++;

         /// printf("%d,",actors[i].anim_timing);

         // Check for frame advance
         //
         if(actors[i].anim_timing >= anim[SET].timing[actors[i].anim_step]) {
             actors[i].anim_step++;
             actors[i].anim_timing = 0;

             // Check for end, or looping
             //
             if(actors[i].anim_step >= anim[SET].total_frames) {
                 if(actors[i].anim_loop) {
                     actors[i].anim_step = 0;
                     actors[i].anim_timing = 0;
                     actors[i].anim_loop--;
                                         }

                 else { actors[i].anim_set = 0; }
                                                               }
                                                                            }

         // If anim is still set, update frame
         // ** SHOULD PLACE IN ROUTINE SO WE CAN SANITY CHECK ANIM_STEP VALUE **
         //
         if(actors[i].anim_set) {
             SET = actors[i].anim_set;
             actors[i].cel_x = anim[SET].frame_x[actors[i].anim_step];
             actors[i].cel_y = anim[SET].frame_y[actors[i].anim_step];
                                }
                                                 }
                             }


 // Floating object animation
 //
 anims[2] += 1.0;
 if(anims[2] > 360.00) { anims[2] -= 360.00; }


 // Flashing mini-map indicator animation
 //
 anims[3] += 0.04;
 if(anims[3] > 1.00) { anims[3] -= 1.00; }


 // UI selection pulsing animation
 //
 anims[4] += 4.0;
 if(anims[4] > 360.00) { anims[4] -= 360.00; }


 // Quake damage pulsing (fed into sin())
 //
 anims[5] += 8.0;
 if(anims[5] > 360.00) { anims[5] -= 360.00; }


 // Holding position shuffle (slow, lazy sine)
 //
 anims[6] += 0.01;
 if(anims[6] > 360.00) { anims[6] -= 360.00; }


 // Flashing Title indicator (50% to 100% opacity)
 //
 anims[7] += 0.04;
 if(anims[7] > 360.00) { anims[7] -= 360.00; }


 // Cape waving animation (fed into sin())
 //
 anims[8] += 8.0;
 if(anims[8] > 360.00) { anims[8] -= 360.00; }


 // Signal fade
 //
 anims[9] -= 0.01;
 if(anims[9] < 0.00) { anims[9] = 0.00; }


 // Title emoji rotation (360 degrees X 4)
 //
 anims[14] += 2.0;
 if(anims[14] >= 1440.00) { anims[14] -= 1440.00; }


 // Title emoji animation
 //
 anims[15] += 2.0;
 if(anims[15] >= 360.00) { anims[15] -= 360.00; }


 return;
}





// NOTE: Keeps track of game time, and parses the ticks left
//       into human readable format
//
void check_time()
{
 div_t d;
 div_t e;

 if(game_mode != 2) { return; }


 if(flags.frozen_salvo > 0)  { flags.frozen_salvo--;  }
 if(flags.drunken_salvo > 0) { flags.drunken_salvo--; }


 // Quake ticks
 //
 quake_ticks--;

 if(quake_ticks <= 0) {
     quake_ticks = quake_base + GetRandomValue(0, quake_spread);
                      }


 return;
}






// Kills off dead actors, spawns new ones over time
//
void check_actors()
{
 int i        = 0;
 int j        = 0;
 int k        = 0;
 int check    = 0;
 int rando    = 0;

 float volume = 1.0;
 float dist   = 0.0;
 float speed  = 0.0;

 Vector3 coords = { 0, 0 };


 for(i=0; i<MAX_ACTORS; i++) {
     if(actors[i].enabled) {

         if(actors[i].shadow != -1) {
             k = actors[i].shadow;
             actors[k].pos.x = actors[i].pos.x;
             actors[k].pos.y = actors[i].pos.y - 1;
             actors[k].pos.z = actors[i].pos.z - 6;
                                    }

         // Actor is quaking
         //
         if(actors[i].quake > 0.000) {
             actors[i].angle = sin(anims[5]) * actors[i].quake;
             actors[i].quake -= 0.15;
             if(actors[i].quake <= 0.000) {
                 actors[i].angle = 0.0;
                 actors[i].quake = 0.0;
                                          }
                                     }

         // Actor is sprite rolling, angle rolling, or flickering
         //
         if(actors[i].roll > 0.001 || actors[i].roll < -0.001) { actors[i].angle += actors[i].roll; }
         if(actors[i].v_roll > 0.001 || actors[i].v_roll < -0.001) { actors[i].v_angle += actors[i].v_roll; }

         if(actors[i].flicker) { actors[i].blend = 0.25 + (float)GetRandomValue(0, 500) / 1000.0; }



         switch(actors[i].state) {
             case 0: // Inactive
                     break;

             case 2: // Waits for stamina to run out. Then dies
                     actors[i].stamina--;
                     if(actors[i].stamina <= 0) {
                         actors[i].flicker = 0;
                         actors[i].blend -= 0.02;
                         if(actors[i].blend <= 0.0) { kill_actor(i); }
                                                }
                     break;

             case 3: // Amiga ball animation; moves from top of screen
                     actors[i].moved_wait++;

                     k = 10 - (actors[i].stamina / 100);
                     if(actors[i].moved_wait >= k) {
                         actors[i].cel_x++;
                         if(actors[i].cel_x > 27) { actors[i].cel_x = 0; }
                         actors[i].moved_wait = 0;
                                                   }

                     if(actors[i].pos.z > 0) {
                         actors[i].v_speed += 0.10;
                         actors[i].pos.z += cos(actors[i].v_angle * (PI / 180.0)) * actors[i].v_speed;
                                             }
                     else {
                         flags.invulnerable = 1;
                         actors[i].stamina--;
                         if(actors[i].stamina <= 0) {
                             actors[i].blend -= 0.02;
                             if(actors[i].blend <= 0.0) { kill_actor(i); flags.invulnerable = 0; }
                                                    }
                          }
                     break;

             case 4: // Fading out, then expiring
                     actors[i].blend -= 0.03;
                     if(actors[i].blend <= 0.00 ) { kill_actor(i); }
                     break;

             case 5: // Shot: Angle + speed movement
                     if(actors[i].pos.x < -50 || actors[i].pos.x > (SCREEN_W + 50)) { kill_actor(i); break; }
                     if((actors[i].pos.y - actors[i].pos.z) < -50 || (actors[i].pos.y - actors[i].pos.z) > (SCREEN_H + 50)) { kill_actor(i); break; }

                     // Apply motion
                     //
                     actors[i].pos.x += sin(actors[i].v_angle * (PI / 180.0)) * actors[i].v_speed;
                     actors[i].pos.y -= cos(actors[i].v_angle * (PI / 180.0)) * actors[i].v_speed;

                     // If regular shot, check for collision with player
                     // If reflected shot, check for collision with lanterns
                     //
                     if(actors[i].cel_x != 7) {
                         check = check_collision(i, puppet, 32, 10);
                         if(check) {
                             actors[i].cel_x    = 7;
                             actors[i].v_roll   = 0.0;
                             actors[i].v_speed *= 2.0;
                             actors[i].stamina += 1000;
                             rando = GetRandomValue(0,100);
                             if(rando & 1) { actors[i].v_angle = GetRandomValue(210, 270); }  // 270 base
                             else          { actors[i].v_angle = GetRandomValue(90, 150);  }  //  90 base
                             break;
                                   }
                                              }
                     else {
                         for(j=0; j<MAX_LAMPS; j++) {
                             check = check_collision(i, lamps[j], 32, 32);
                             if(check) {
                                 kill_actor(i);
                                 damage_lantern(lamps[j], 50);
                                 break;
                                       }
                                                    }
                          }

                     actors[i].stamina--;
                     if(actors[i].stamina <= 0) {
                         actors[i].blend -= 0.02;
                         if(actors[i].blend <= 0.0) { kill_actor(i); }
                                                }
                     break;

             case 6: // Moon. Slow elliptical orbit (unless frozen)
                     if(flags.frozen_salvo > 0) { speed = actors[i].v_speed * 0.25; }
                     else                       { speed = actors[i].v_speed;        }

                     actors[i].pos.x += sin(actors[i].v_angle * (PI / 180.0)) * speed;
                     actors[i].pos.y -= cos(actors[i].v_angle * (PI / 180.0)) * (speed / 8.0);
                     break;

             case 7: /// Angle + Speed movement (ON Z AXIS ONLY).
                     actors[i].pos.x += sin(actors[i].v_angle * (PI / 180.0)) * actors[i].v_speed;
                     actors[i].pos.z += cos(actors[i].v_angle * (PI / 180.0)) * actors[i].v_speed;

                     actors[i].stamina--;
                     if(actors[i].stamina <= 0) { kill_actor(i); }
                     break;

             case 8: // Lanterns (respond to being hit by flashing red)
                     if(actors[i].extra > 0) {
                         actors[i].extra--;
                         actors[i].color = RED;
                                             }
                     else { actors[i].color = WHITE; }
                     break;

            case 12: // Terminal Eidolon
                     // Spawns center top or bottom, moves across screen; speeds up and fades out
                     actors[i].v_speed += 0.05;
                     actors[i].pos.z += cos(actors[i].v_angle * (PI / 180.0)) * actors[i].v_speed;

                     if(!actors[i].moved_down) {
                         if(actors[i].pos.z < 500) {
                             for(j=0; j<MAX_LAMPS; j++) { spawn_shield_ball(lamps[j]); }
                             actors[i].moved_down = 1;
                                                   }
                                               }

                     actors[i].stamina--;
                     if(actors[i].stamina <= 0) { kill_actor(i); }
                     break;

            case 13: // Ouroborus Eidolon
                     // Spawns center top or bottom, moves across screen; speeds up and fades out
                     actors[i].v_speed += 0.05;
                     actors[i].pos.z += cos(actors[i].v_angle * (PI / 180.0)) * actors[i].v_speed;

                     if(!actors[i].extra) {
                         if(actors[i].pos.z >= -75) {
                             actors[i].extra = 1;
                             spawn_vortex(actors[i].pos.x, actors[puppet].pos.y - 10, 200);
                                                    }
                                          }

                     actors[i].stamina--;
                     if(actors[i].stamina <= 0) { kill_actor(i); }
                     break;

            case 14: // Fire Dragon Eidolon
                     // Spawns on the side, slows down as it approaches mid-screen
                     actors[i].v_speed -= 0.068;
                     actors[i].pos.x += sin(actors[i].v_angle * (PI / 180.0)) * actors[i].v_speed;

                     if(abs(actors[i].v_speed) < 5.0) {
                         spawn_fireball(actors[i].pos.x, actors[i].pos.y, 250, actors[i].extra);
                         spawn_fireball(actors[i].pos.x, actors[i].pos.y, 250, actors[i].extra);
                                                      }

                     // If actor has reversed direction, repair lamps on other side (okay to execute continually)
                     //
                     if(actors[i].v_speed < -2.0) {
                         if(!actors[i].extra) {
                             for(j=4; j<MAX_LAMPS; j++) { damage_lantern(lamps[j], -1); }
                                              }
                         else {
                             for(j=0; j<4; j++) { damage_lantern(lamps[j], -1); }
                              }
                                                  }

                     actors[i].stamina--;
                     if(actors[i].stamina <= 0) {
                         actors[i].blend -= 0.02;
                         if(actors[i].blend <= 0.0) { kill_actor(i); }
                                                }
                     break;

            case 15: // Wind Dragon Eidolon
                     // Spawns on the side, slows down as it approaches mid-screen
                     actors[i].v_speed -= 0.040;
                     actors[i].pos.x += sin(actors[i].v_angle * (PI / 180.0)) * actors[i].v_speed;

                     if(abs(actors[i].v_speed) < 5.0) {
                         spawn_frostball(actors[i].pos.x, actors[i].pos.y, 250, actors[i].extra);
                                                      }

                     // Makes shots "frozen"
                     //
                     if(abs(actors[i].v_speed) < 0.5) { flags.frozen_salvo = 1000; }

                     actors[i].stamina--;
                     if(actors[i].stamina <= 0) {
                         actors[i].blend -= 0.02;
                         if(actors[i].blend <= 0.0) { kill_actor(i); }
                                                }
                     break;
                                 }
                           }
                             }

 return;
}












void kill_actor(int slot)
{

 // Basic Sanity Check
 //
 if(slot < 0 || slot >= MAX_ACTORS) { printf("ERROR: Invalid slot in kill command. Slot = %d", slot); return; }

 int i = 0;

 actors[slot].enabled     = 0;
 actors[slot].projected   = 0;
 actors[slot].mirror      = 0;
 actors[slot].team        = 0;
 actors[slot].decal       = 0;
 actors[slot].shader      = 0;
 actors[slot].shadow      = -1;
 actors[slot].accessory   = 0;
 actors[slot].y_shift     = 0;
 actors[slot].gravity     = 0;
 actors[slot].flicker     = 0;
 actors[slot].anim_set    = 0;
 actors[slot].anim_step   = 0;
 actors[slot].anim_timing = 0;
 actors[slot].anim_loop   = 0;
 actors[slot].effect      = 0;
 actors[slot].state       = 0;
 actors[slot].mode        = 0;
 actors[slot].flip        = 0;
 actors[slot].timer       = 0;
 actors[slot]._size_w     = 16; // Default value
 actors[slot]._size_h     = 16; // Default value
 actors[slot].home        = -1;
 actors[slot].extra       = 0;
 actors[slot].event       = 0;
 actors[slot].locked_to   = -1;
 actors[slot].scale       = 1.0;
 actors[slot].v_angle     = 0.0;
 actors[slot].v_roll      = 0.0f;
 actors[slot].v_speed     = 0.0f;
 actors[slot].blend       = 1.0f;
 actors[slot].angle       = 0.0f;
 actors[slot].roll        = 0.0f;
 actors[slot].quake       = 0.0f;
 actors[slot].sinking     = 0.0f;
 actors[slot].speed       = 1.0f; // Default value
 actors[slot].stamina     = 1000;

 actors[slot].scale_ramp  = 0.0;
 actors[slot].scale_mod   = 1.0;
 actors[slot].scale_up    = 0.0;
 actors[slot].scale_down  = 0.0;

 actors[slot].updates     = 1;
 actors[slot].moved_up    = 0;
 actors[slot].moved_down  = 0;
 actors[slot].moved_wait  = 0;

 for(i=0; i<4; i++) { actors[slot].d_pad[i] = 0; actors[slot].buttons[i] = 0; }

 for(i=0; i<10; i++) { actors[slot].s_vars[i] = 0.0; }

 actors[slot].path.x      = 0;
 actors[slot].path.y      = 0;
 actors[slot].path.z      = 0;

 actors[slot].pos.x       = 0;
 actors[slot].pos.y       = 0;
 actors[slot].pos.z       = 0;

 actors[slot].dest.x      = 0;
 actors[slot].dest.y      = 0;
 actors[slot].dest.z      = 0;

 actors[slot].offset.x    = 0;
 actors[slot].offset.y    = 0;
 actors[slot].offset.z    = 0;

 actors[slot].cel         = tex_16x;
 actors[slot].color       = WHITE;
 return;
}






// Spawns a new actor. Types are 0-x for default skin
//
int spawn_actor(int type, float x, float y, float z, int cell_x, float path_x, float path_y, float path_z)
{
 int i    = 0;
 int slot = get_free_actor();

 // Basic Sanity Check
 //
 if(slot < 0 || slot >= MAX_ACTORS) { return(-1); }

 actors[slot].mode      = 0;
 actors[slot].visible   = 1;
 actors[slot].effect    = 0;
 actors[slot].projected = 1;
 actors[slot].blend     = 1.0f;
 actors[slot].angle     = 0.0f;
 actors[slot].timer     = 0;
 actors[slot].stamina   = GetRandomValue(500, 1200); // was 350, 500
 actors[slot].v_angle   = 0.0;
 actors[slot].locked_to = -1;

 actors[slot].pos.x     = x;
 actors[slot].pos.y     = y;
 actors[slot].pos.z     = z;

 actors[slot].path.x    = path_x;
 actors[slot].path.y    = path_y;
 actors[slot].path.z    = path_z;

 actors[slot].cel       = tex_16x; // default value
 actors[slot].cel_x     = cell_x;
 actors[slot].cel_y     = 0;

 actors[slot].state     = 0;
 actors[slot].scale     = 1.0;

 actors[slot].enabled = 1;

 return(slot);
}







// Returns a slot to a free actor.
// If something goes wrong, we will clobber actor 0.
// Do something more graceful later
//
int get_free_actor()
{
 int i = 0;

 for(i=1; i<MAX_ACTORS; i++) {
     if(!actors[i].enabled) { return(i); }
                             }

 return(0);
}




// NOTE: Used to initially populate important stuff that'll never change between sessions
//
void spawn_permanent_actors()
{
 int i = 0;
 Vector2 dest      = { 0 };
 Color col         = BLANK;
 Color brush_start = (Color){  35,  23, 11, 255 };
 Color brush_end   = (Color){ 188, 126, 60, 255 };

 float scale       = 0.0;
 float start_x[18] = { -100.0, 0.0, -250.0, -175.0, -47.0, -145.0, -100.0, 0.0, -250.0, -175.0, -47.0, -145.0,
                       -32.0, -96.0, -200.0, -128.0, 0.0, -83.0 };

 // This is only valid if MAX_LAMPS is 8.
 // Shit coding. Fight me.
 //
 float lamp_pos_x[8] = { 120.0, 240.0, 360.0, 500.0, 780, 920.0, 1040.0, 1160.0 };
 float lamp_pos_y[8] = { 848.0, 908.0, 956.0, 1002.0, 1002.0, 956.0, 908.0, 848.0 };
 float lamp_pos_z[8] = {   0.0,   8.0,   16.0,  16.0,  16.0,  16.0,   8.0,  0.0 };
/*
 float lamp_pos_x[8] = { 120.0, 240.0, 360.0, 500.0, 780, 920.0, 1040.0, 1160.0 };
 float lamp_pos_y[8] = { 748.0, 808.0, 858.0, 902.0, 902.0, 858.0, 808.0, 748.0 };
 float lamp_pos_z[8] = {  -8.0,   0.0,   4.0,   8.0,   8.0,   4.0,   0.0,  -8.0 };
*/
 // Create player
 //
 puppet = spawn_ghost(640, 935, 104);
 if(puppet == -1) { printf("Fatal error. Couldn't spawn player. Baborting."); exit(0); }


 for(i=0; i<18; i++) {
     dest.x = start_x[i];
     dest.y = SCREEN_H - 260 + (20 * i);
     col = FR_grab_gradient(brush_start, brush_end, 0.0, (float)i * 0.054);
     scale = 2.0 + (0.15 * i);
     spawn_brush(dest.x, dest.y, col, scale);
                     }

 shrine = spawn_shrine(640, 895); // was 795
 moon   = spawn_moon();

 for(i=0; i<MAX_LAMPS; i++) {
     lamps[i] = spawn_lantern(lamp_pos_x[i], lamp_pos_y[i], lamp_pos_z[i]);
                            }


 // Initialize oscillator (Red)
 //
 oscillators[0].angle      = GetRandomValue(0, 360);
 oscillators[0].roll       = 2.0;
 oscillators[0].cur_time   = 0.0;
 oscillators[0].max_time   = 0.10;
 oscillators[0].shot_queue = 100;
 oscillators[0].shot_type  = 1;

 // Initialize oscillator (Green)
 //
 oscillators[1].angle      = GetRandomValue(0, 360);
 oscillators[1].roll       = 1.5;
 oscillators[1].cur_time   = 0.0;
 oscillators[1].max_time   = 0.20;
 oscillators[1].shot_queue = 100;
 oscillators[1].shot_type  = 2;

 // Initialize oscillator (Blue)
 //
 oscillators[2].angle      = GetRandomValue(0, 360);
 oscillators[2].roll       = -6.0;
 oscillators[2].cur_time   = 0.0;
 oscillators[2].max_time   = 0.025;
 oscillators[2].shot_queue = 100;
 oscillators[2].shot_type  = 3;

 // Initialize oscillator (Yellow)
 //
 oscillators[3].angle      = GetRandomValue(0, 360);
 oscillators[3].roll       = -3.0;
 oscillators[3].cur_time   = 0.0;
 oscillators[3].max_time   = 0.15;
 oscillators[3].shot_queue = 100;
 oscillators[3].shot_type  = 4;


 return;
}





void draw_actor(int slot)
{
 // Basic Sanity Check
 //
 if(slot < 0 || slot >= MAX_ACTORS) { return; }

 if(!actors[slot].enabled) { return; }
 if(!actors[slot].visible) { return; }

 float x_flip    = 1.0;
 float dist      = 0.0;
 float x_diff    = 0.0;
 float y_diff    = 0.0;

 Vector2 coords  = { actors[slot].pos.x, actors[slot].pos.y };
 Vector2 coords2 = { 0, 0 };
 Vector2 origin  = { (actors[slot]._size_w / 2) * actors[slot].scale, (actors[slot]._size_h / 2) * actors[slot].scale };

 total_actors++;

 // Flip sprite horizontally if path of travel is negative on x axis
 //
 if(actors[slot].flip) { x_flip = -1.0; /*s_flip = - 4;*/ }

 Rectangle source  = { (actors[slot]._size_w * actors[slot].cel_x), (actors[slot]._size_h * actors[slot].cel_y), actors[slot]._size_w * x_flip, actors[slot]._size_h };

 if(actors[slot].sinking) {
     source.height -= actors[slot].sinking;
                          }


 /// Setting the origin influences these values
 /// Note that we don't need to center the destination on the X axis
 ///                       vv vv vv vv
 Rectangle dest     = { actors[slot].pos.x, actors[slot].pos.y - ((actors[slot]._size_h * actors[slot].scale) / 2) - actors[slot].pos.z, (actors[slot]._size_w * actors[slot].scale), (actors[slot]._size_h * actors[slot].scale) };

 //dest.y -= actors[slot].pos.z;


 if(actors[slot].mirror) { source.width *= -1; }

 switch(actors[slot].effect) {
     case 1: // Normal blit + wave shader (LAMP SINE)
             SetShaderValue(wave,  freqXLoc, &l_vars[0], SHADER_UNIFORM_FLOAT);
             SetShaderValue(wave,  freqYLoc, &l_vars[1], SHADER_UNIFORM_FLOAT);
             SetShaderValue(wave,  ampXLoc,  &l_vars[2], SHADER_UNIFORM_FLOAT);
             SetShaderValue(wave,  ampYLoc,  &l_vars[3], SHADER_UNIFORM_FLOAT);
             SetShaderValue(wave, speedXLoc, &l_vars[4], SHADER_UNIFORM_FLOAT);
             SetShaderValue(wave, speedYLoc, &l_vars[5], SHADER_UNIFORM_FLOAT);

             BeginShaderMode(wave);
                 DrawTexturePro(actors[slot].cel, source, dest, origin, actors[slot].angle, Fade(actors[slot].color, actors[slot].blend));
             EndShaderMode();
             break;

     case 2: // Custom code for brush (BRUSH SINE);
             SetShaderValue(wave,  freqXLoc, &s_vars[0], SHADER_UNIFORM_FLOAT);
             SetShaderValue(wave,  freqYLoc, &s_vars[1], SHADER_UNIFORM_FLOAT);
             SetShaderValue(wave,  ampXLoc,  &s_vars[2], SHADER_UNIFORM_FLOAT);
             SetShaderValue(wave,  ampYLoc,  &s_vars[3], SHADER_UNIFORM_FLOAT);
             SetShaderValue(wave, speedXLoc, &s_vars[4], SHADER_UNIFORM_FLOAT);
             SetShaderValue(wave, speedYLoc, &s_vars[5], SHADER_UNIFORM_FLOAT);

             BeginShaderMode(wave);
                 DrawTextureEx(actors[slot].cel, (Vector2){actors[slot].pos.x,   (actors[slot].pos.y - (32.0 * actors[slot].scale))}, 0.0, actors[slot].scale, Fade(actors[slot].color, actors[slot].blend));
             EndShaderMode();
             break;

     case 3: // Additive blur
             BeginBlendMode(BLEND_ADDITIVE);
             blend_helper(actors[slot].cel, source, dest, origin, actors[slot].angle, Fade(actors[slot].color, actors[slot].blend * 0.10));
             EndBlendMode();
             break;

     case 4: // Normal blit + wave shader (FIRE SINE)
             SetShaderValue(wave,  freqXLoc, &f_vars[0], SHADER_UNIFORM_FLOAT);
             SetShaderValue(wave,  freqYLoc, &f_vars[1], SHADER_UNIFORM_FLOAT);
             SetShaderValue(wave,  ampXLoc,  &f_vars[2], SHADER_UNIFORM_FLOAT);
             SetShaderValue(wave,  ampYLoc,  &f_vars[3], SHADER_UNIFORM_FLOAT);
             SetShaderValue(wave, speedXLoc, &f_vars[4], SHADER_UNIFORM_FLOAT);
             SetShaderValue(wave, speedYLoc, &f_vars[5], SHADER_UNIFORM_FLOAT);

             BeginShaderMode(wave);
                 DrawTexturePro(actors[slot].cel, source, dest, origin, actors[slot].angle, Fade(actors[slot].color, actors[slot].blend));
             EndShaderMode();
             break;

     case 8: // Dirty hack for Amiga ball
             x_diff = (tex_ball[0].width / 2.0) * actors[slot].scale; // Zero offset is okay. Don't care.
             y_diff = (tex_ball[0].height) * actors[slot].scale;      // Ditto
             DrawTextureEx(tex_ball[actors[slot].cel_x], (Vector2){actors[slot].pos.x - x_diff, (actors[slot].pos.y - actors[slot].pos.z - y_diff)}, 0.0, actors[slot].scale, Fade(actors[slot].color, actors[slot].blend));
             break;

    case 99: // Do nothing (if visibility is being fucked with)
             break;

    default: // Normal blit
             /// Uncomment if shadows are supported in this project
             //if(actors[slot].shadow && actors[slot].pos.y < 0.2) {
             //    DrawTexturePro(tex_sprites, (Rectangle){32, 0, 16, 16}, dest, origin, actors[slot].angle, Fade(actors[slot].color, actors[slot].blend));
             //                                                    }

             /// Debugging lines ///
             /// DrawLine(0, actors[slot].pos.y, 2000, actors[slot].pos.y, WHITE);
             /// DrawLine(actors[slot].pos.x, 0, actors[slot].pos.x, 2000, WHITE);

             DrawTexturePro(actors[slot].cel, source, dest, origin, actors[slot].angle, Fade(actors[slot].color, actors[slot].blend));
             break;
                             }



 return;
}





// NOTE: This is only called by the above routine, when blending, to keep the code from being jank
//
void blend_helper(Texture2D source, Rectangle rect_s, Rectangle rect_d, Vector2 origin, float angle, Color tint)
{
 float drift = 2;

 DrawTexturePro(source, rect_s, rect_d, origin, angle, tint);

 rect_d.x -= drift;
 DrawTexturePro(source, rect_s, rect_d, origin, angle, tint);

 rect_d.x += drift;
 rect_d.y -= drift;
 DrawTexturePro(source, rect_s, rect_d, origin, angle, tint);

 rect_d.x += drift;
 rect_d.y += drift;
 DrawTexturePro(source, rect_s, rect_d, origin, angle, tint);

 rect_d.x -= drift;
 rect_d.y += drift;
 DrawTexturePro(source, rect_s, rect_d, origin, angle, tint);


 // Next pass
 //
 drift = 1;

 rect_d.x -= drift;
 DrawTexturePro(source, rect_s, rect_d, origin, angle, tint);

 rect_d.x += drift;
 rect_d.y -= drift;
 DrawTexturePro(source, rect_s, rect_d, origin, angle, tint);

 rect_d.x += drift;
 rect_d.y += drift;
 DrawTexturePro(source, rect_s, rect_d, origin, angle, tint);

 rect_d.x -= drift;
 rect_d.y += drift;
 DrawTexturePro(source, rect_s, rect_d, origin, angle, tint);

 return;
}





// NOTE: This is used to put a soft additive glow on the eyes
//       Can't use the above routine because the call is to EX instead of pro, and I'm fucking lazy
//
void blend_helper_ex(Texture2D source,  Vector2 dest, float angle, float scale, Color tint)
{
 float drift = 3;

 DrawTextureEx(source, dest, angle, scale, tint);

 dest.x -= drift;
 DrawTextureEx(source, dest, angle, scale, tint);

 dest.x += drift;
 dest.y -= drift;
 DrawTextureEx(source, dest, angle, scale, tint);

 dest.x += drift;
 dest.y += drift;
 DrawTextureEx(source, dest, angle, scale, tint);

 dest.x -= drift;
 dest.y += drift;
 DrawTextureEx(source, dest, angle, scale, tint);


 drift = 1;
 dest.x -= drift;
 DrawTextureEx(source, dest, angle, scale, tint);

 dest.x += drift;
 dest.y -= drift;
 DrawTextureEx(source, dest, angle, scale, tint);

 dest.x += drift;
 dest.y += drift;
 DrawTextureEx(source, dest, angle, scale, tint);

 dest.x -= drift;
 dest.y += drift;
 DrawTextureEx(source, dest, angle, scale, tint);

 return;
}





int get_population(int team)
{
 int i = 0;
 int total = 0;

 for(i=1; i<MAX_ACTORS; i++) {
     if(actors[i].enabled) {
         if(actors[i].team == team) { total++; }
                           }
                             }

 return(total);
}






// NOTE: Draws the top/bottom banners for the title screen
//       Should only have minor changes between projects
//
void draw_title_hud()
{
 float   angle    = 0.0;
 Vector2 pos      = { 0, 0 };
 Vector2 len      = { 0, 0 };
 Vector2 origin   = { 128.0f, 128.0f };
 Rectangle source = { 0.0f, 0.0f, 128.0f, 128.0f };
 Rectangle dest   = { 0.0f, 0.0f, 256.0f, 256.0f };

 div_t d;


 len   = MeasureTextEx(font1, "PRESS [Z] TO START", font1.baseSize, 1);
 pos.x = (SCREEN_W / 2) - (len.x / 2);
 pos.y = SCREEN_H - 24;

 sprintf(custom_text, "PRESS [Z] TO START");
 DrawTextEx(font1, custom_text, pos, font1.baseSize, 1, Fade(WHITE, (1.0 * anims[3])));

 return;
}







void draw_hud()
{
 Vector2 len = { 0, 0 };
 Vector2 pos = { 0, 0 };

 DrawTextEx(font1, "- SCORE -", (Vector2){ 1052, 12 }, font1.baseSize, 1, YELLOW);
 sprintf(custom_text, "%08d", score);
 DrawTextEx(font1, custom_text, (Vector2){  996, 28 }, font1.baseSize * 2, 1, WHITE);

 // Draw Control Hints
 //
 DrawTextEx(font3, "ARROW KEYS - MOVE OR SELECT TILE                                         Z (HOLD) - TILE MENU", (Vector2){80, SCREEN_H - 16}, font3.baseSize * 3, 3, Fade(BLACK, 0.75));
 DrawTextEx(font3, "ARROW KEYS                                                               Z (HOLD)", (Vector2){80, SCREEN_H - 16}, font3.baseSize * 3, 3, Fade(ORANGE, 1.00));


 return;
}





// NOTE: Draws the actual title screen, with animations and whatnot
//
void draw_title()
{
 int i            = 0;
 int x            = 0;
 int y            = 0;

 float alpha      = 0.0;
 float angle      = 0.0;

 Vector2 origin   = { 0, 0 };
 Vector2 pos      = { 0, 0 };
 Rectangle source = { 0 };
 Rectangle dest   = { 0 };


 // Draw 4 emoji inside sparkles, with animation
 //
 for(i=0; i<4; i++) {
     x = 200 + (i * 250);
     y = 320;

     // This creates a sine 'pulse' for the rotation angle
     //
     t_angle[i] += 2.0 + ((sin(anims[6] + t_offset[i]) * rad_conv) * 60.0);
     if(t_angle[i] >= 360.00) { t_angle[i] -= 360.00; }

     // Sparkle background
     //
     push_rect(&source, 0, 0, 256, 256);
     push_rect(&dest, x + 64, y + 64, 512, 512);
     origin.x = 256;
     origin.y = 256;

     DrawTexturePro(tex_sparkle, source, dest, origin, t_angle[i], Fade(ORANGE, (0.15 * anims[0])));


     // Emoji
     //
     push_rect(&source, i * 128, 0, 128, 128);
     push_rect(&dest, x, y, 128, 128);
     origin.x = 0;
     origin.y = 0;

     DrawTexturePro(tex_emoji, source, dest, origin, angle, Fade(WHITE, (0.50 * anims[0])));
                    }


 // Center title a little low vertically
 //
 pos.x = (SCREEN_W / 2) - (tex_title.width / 2);
 alpha = sin(anims[7]) * 0.25;
 DrawTexture(tex_title, pos.x, 350, Fade(WHITE, (0.85 + alpha)));

 return;
}






void draw_signal(int signal)
{
 float dest_x = SCREEN_W / 2.0;
 float dest_y = SCREEN_H / 4.0;


 if(signal == 0) {
     ///dest_x -= tex_ball.width;
     ///DrawTextureEx(tex_ball,   (Vector2){dest_x, dest_y}, 0.0, 2.0, Fade(WHITE, anims[9]));
                 }

 if(signal == 1) {
     ///dest_x -= tex_strike.width;
     ///DrawTextureEx(tex_strike, (Vector2){dest_x, dest_y}, 0.0, 2.0, Fade(WHITE, anims[9]));
                 }


 // Dodgy, but we'll kill the signal off in here because I'm lazy
 //
 if(anims[9] <= 0.01) { show_signal = -1; }


 return;
}






// Copied-over framework stuff goes here



void FR_merge_actors()
{
 int i = 0;

 // Decals first
 //
 for(i=0; i<MAX_ACTORS; i++) {
     if(sorted[i][1] != -1) {
         if(actors[sorted[i][1]].decal) { draw_actor(sorted[i][1]); }
                            }
                             }


 // Everything else
 //
 for(i=0; i<MAX_ACTORS; i++) {
     if(sorted[i][1] != -1) {
         if(!actors[sorted[i][1]].decal) { draw_actor(sorted[i][1]); }
                            }
                             }

 return;
}







// Add hook to allow for different manners of sorting outside the framework
//
// NOTE: For use with quicksort implementation
//
void FR_prep_for_sort()
{
 int i    = 0;

     for(i=0; i<MAX_ACTORS; i++) {
         sorted[i][0] = -1;
         sorted[i][1] = -1;

         if(actors[i].enabled && !actors[i].accessory) {
             sorted[i][0] = actors[i].pos.y;
             sorted[i][1] = i;
                                                       }
                                 }

 return;
}






// NOTE: OLD CODE IS OLD. Quicksort. Does what it says, says what it does.
//
void FR_quicksort(int low, int high)
{
 int top    = low;
 int bottom = (high - 1);
 int part_index;
 int part_value;

 if (low < high) {

     // Check if elements are sequential
     //
     if(high == (low + 1)) {
         if(sorted[low][0] > sorted[high][0]) { FR_swap_int(high, low, 0); }
                           }

     else {
         // Choose a partition element and swap it with
         // the last value in the array
         //
         part_index = (int)((low + high) / 2);
         part_value = sorted[part_index][0];
         FR_swap_int(high, part_index, 0);

         do {
	         // Inrement the top pointer
             //
	         while((sorted[top][0] <= part_value) && (top <= bottom)) { top++; }

	         // Decrement the bottom pointer
             //
	         while((sorted[bottom][0] > part_value) && (top <= bottom)) { bottom--; }

             // Swap elements if pointers have not met
             //
	         if(top < bottom) { FR_swap_int(top, bottom, 0); }
            } while(top < bottom);

     FR_swap_int(top, high, 0);

     // Recursive calls
     //
     FR_quicksort(low, top - 1);
     FR_quicksort(top + 1, high);
          }

                 }

 return;
}






// NOTE: OLD CODE IS OLD. For use with quicksort implementation
//
void FR_swap_int(int n1, int n2, int index)
{
 int temp;
 int temp2;

 temp  = sorted[n1][0];
 temp2 = sorted[n1][1];

 sorted[n1][0] = sorted[n2][0];
 sorted[n1][1] = sorted[n2][1];

 sorted[n2][0] = temp;
 sorted[n2][1] = temp2;

 return;
}







// OLD CODE IS OLD.
//
int FR_2d_dist(int x1, int y1, int x2, int y2)
{
 double d_x, d_y;
 double distance;

 d_x = x1 - x2;
 d_y = y1 - y2;

 d_x *= d_x;
 d_y *= d_y;

 distance = sqrt((d_x + d_y));

 return((int)distance);
}










void init_game_variables()
{
 int i = 0;
 int j = 0;

 score        = 0;
 score_diff   = 0;
 score_shake  = 0;
 score_ticks  = 0;
 slow_time    = 0;
 slow_frame   = 0;
 yes_no       = 0;
 select       = 0;
 accept       = 0;
 puppet       = -1;
 show_signal  = -1;
 swing_active = 0;
 swung        = 0;


 for(i=0; i<16; i++) { sfx_buffer[i][0] = -1; sfx_buffer[i][1] = 0; }
 for(i=0; i<16; i++) { anims[i] = 1.0; }

 for(i=0; i<MAX_TEXTBOX; i++) {
     textbox[i].pos.x = 0.0;
     textbox[i].pos.y = 0.0;
     textbox[i].pos.width  = 0;
     textbox[i].pos.height = 0;
     textbox[i].scale = 0.0;
     textbox[i].mode = 0;
     textbox[i].ticks = 0;
     textbox[i].viewable_text = 0;
     textbox[i].msg = NULL;
     textbox[i].enabled = 0;
                              }



 // Define camera (this will center camera, with focus in middle of screen for rotation)
 // Suitable for use with zooming
 //
 camera.target   = (Vector2){ (float)SCREEN_W / 2.0f, (float)SCREEN_H / 2.0f };
 camera.offset   = (Vector2){ (float)SCREEN_W / 2.0f, (float)SCREEN_H / 2.0f };
 camera.rotation = 0.0f;
 camera.zoom     = 1.0f;


/*
 // Define camera (this will be a static camera locked to upper-left corner)
 // Not suitable for use with rotation. Zooming only.
 //
 camera.target   = (Vector2){ 0.0f, 0.0f };
 camera.offset   = (Vector2){ 0.0f, 0.0f };
 camera.rotation = 0.0f;
 camera.zoom     = 1.0f;
*/

 // Set up actors and spawns
 //
 for(i=0; i<MAX_ACTORS; i++) { kill_actor(i); }

 spawn_permanent_actors();

 game_over     = 0;
 box_tex_x     = 0;
 box_tex_y     = 0;
 box_update    = 0;
 game_ticks    = SESSION_TIME;
 frame_ticks   = 0;
 game_mode     = 0;

 flags.invulnerable  = 0;
 flags.frozen_salvo  = 0;
 flags.drunken_salvo = 0;
 flags.selected      = -1;
 flags.charge[0] = 0;
 flags.charge[1] = 0;
 flags.charge[2] = 0;
 flags.charge[3] = 0;


 for(i=0; i<MAX_LAMPS; i++) { damage_lantern(i, -1); }

 return;
}









// Ends game upon time-out.
// Player gets a review of their stats
// Player is then booted to the title screen (vars need to be reset)
//
void end_game()
{
 int exit = 0;
 int key  = 0;

 game_mode = 3;
 camera.rotation = 0.00;
 camera.zoom     = 1.00;


 do {
     update_and_render();
    } while(!IsKeyDown(KEY_Z));

 PlaySound(sfx[2]);

 do {
     update_and_render();
    } while(IsKeyDown(KEY_Z));


 return;
}






// Out of laziness, check each key and send back anything unique
// Valid keys are A-Z and 0-9. Returns 0 if no button seen
//
int get_initial()
{
 int check = 0;

 if(IsKeyPressed(KEY_A)) { return(65); }

 if(IsKeyPressed(KEY_B))  { return(66); }
 if(IsKeyPressed(KEY_C))  { return(67); }
 if(IsKeyPressed(KEY_D))  { return(68); }
 if(IsKeyPressed(KEY_E))  { return(69); }
 if(IsKeyPressed(KEY_F))  { return(70); }
 if(IsKeyPressed(KEY_G))  { return(71); }

 if(IsKeyPressed(KEY_H))  { return(72); }
 if(IsKeyPressed(KEY_I))  { return(73); }
 if(IsKeyPressed(KEY_J))  { return(74); }
 if(IsKeyPressed(KEY_K))  { return(75); }
 if(IsKeyPressed(KEY_L))  { return(76); }
 if(IsKeyPressed(KEY_M))  { return(77); }
 if(IsKeyPressed(KEY_N))  { return(78); }
 if(IsKeyPressed(KEY_O))  { return(79); }
 if(IsKeyPressed(KEY_P))  { return(80); }

 if(IsKeyPressed(KEY_Q))  { return(81); }
 if(IsKeyPressed(KEY_R))  { return(82); }
 if(IsKeyPressed(KEY_S))  { return(83); }
 if(IsKeyPressed(KEY_T))  { return(84); }
 if(IsKeyPressed(KEY_U))  { return(85); }
 if(IsKeyPressed(KEY_V))  { return(86); }
 if(IsKeyPressed(KEY_W))  { return(87); }
 if(IsKeyPressed(KEY_X))  { return(88); }
 if(IsKeyPressed(KEY_Y))  { return(89); }
 if(IsKeyPressed(KEY_Z))  { return(90); }

 if(IsKeyPressed(KEY_ZERO))  { return(48); }
 if(IsKeyPressed(KEY_ONE))   { return(49); }
 if(IsKeyPressed(KEY_TWO))   { return(50); }
 if(IsKeyPressed(KEY_THREE)) { return(51); }
 if(IsKeyPressed(KEY_FOUR))  { return(52); }
 if(IsKeyPressed(KEY_FIVE))  { return(53); }
 if(IsKeyPressed(KEY_SIX))   { return(54); }
 if(IsKeyPressed(KEY_SEVEN)) { return(55); }
 if(IsKeyPressed(KEY_EIGHT)) { return(56); }
 if(IsKeyPressed(KEY_NINE))  { return(57); }

 return(check);
}










// NOTE: Allegro-style CPU blitting operation
//
void blit(Image src, Image dest, int s_x, int s_y, int d_x, int d_y, int w, int h)
{
 Rectangle s, d;


 s.x = s_x;
 s.y = s_y;
 s.width  = w;
 s.height = h;

 d.x = d_x;
 d.y = d_y;
 d.width  = w;
 d.height = h;

 ImageDraw(&dest, src, s, d, WHITE);

 return;
}






// Vertically-flipped blit.
//
void blit_v(Image src, Image dest, int s_x, int s_y, int d_x, int d_y, int w, int h)
{
 Rectangle s, d;


 s.x = s_x;
 s.y = s_y;
 s.width  = w;
 s.height = h;

 d.x = d_x;
 d.y = d_y;
 d.width  = w;
 d.height = h;

 Image subs = ImageFromImage(src, s);
 ImageFlipVertical(&subs);

 s.x = 0;
 s.y = 0;
 ImageDraw(&dest, subs, s, d, WHITE);

 UnloadImage(subs);

 return;
}




// Horizontally-flipped blit.
//
void blit_h(Image src, Image dest, int s_x, int s_y, int d_x, int d_y, int w, int h)
{
 Rectangle s, d;


 s.x = s_x;
 s.y = s_y;
 s.width  = w;
 s.height = h;

 d.x = d_x;
 d.y = d_y;
 d.width  = w;
 d.height = h;

 Image subs = ImageFromImage(src, s);
 ImageFlipHorizontal(&subs);

 s.x = 0;
 s.y = 0;
 ImageDraw(&dest, subs, s, d, WHITE);

 UnloadImage(subs);

 return;
}




void assign_animation(int who, int anim, int loops)
{
 // Sanity Check
 //
 if(who < 0 || who >= MAX_ACTORS) { return; }

 actors[who].anim_set    = anim;
 actors[who].anim_step   = 0;
 actors[who].anim_timing = 0;
 actors[who].anim_loop   = loops;

 return;
}





void kill_animation(int who)
{
 // Sanity Check
 //
 if(who < 0 || who >= MAX_ACTORS) { return; }

 actors[who].anim_set    = 0;
 actors[who].anim_step   = 0;
 actors[who].anim_timing = 0;
 actors[who].anim_loop   = 0;

 return;
}





void trigger_textbox(int slot, int x, int y, int w, int h, int message, int delay, int duration)
{

 printf("TEXTBOX\n");
 // Sanity check slot and message

 textbox[slot].pos.x      = x;
 textbox[slot].pos.y      = y;
 textbox[slot].pos.width  = w;
 textbox[slot].pos.height = h;
 textbox[slot].scale      = 0.0;
 textbox[slot].duration   = duration;
 textbox[slot].mode       = 0 - delay;
 textbox[slot].ticks      = 0;
 textbox[slot].viewable_text = 0;
 textbox[slot].msg        = NULL; //hints[message];
 textbox[slot].enabled    = 1;

 return;
}





void show_stats()
{
 bool exit = 0;
 bool enter = 1;

 do {

    if(enter)  { if(!IsKeyDown(KEY_X)) { enter = 0; } }
    if(!enter) { if(IsKeyDown(KEY_X))  { exit  = 1; } }

    update_and_render();

    } while(!exit);

 return;
}







// Draws game over score summary
//
void draw_summary()
{
 int txt_x     = 0;
 float pulse   = 0.0;
 float percent = 0.0;
 Vector2 len   = { 0, 0 };

 // Draw box texture as background
 //
 Rectangle tex_s = { box_tex_x,box_tex_y, 64, 32 };
 Rectangle tex_d = { 0, 0, SCREEN_W, SCREEN_H };
 DrawTextureTiled(box_tex, tex_s, tex_d, (Vector2){0,0}, 0.0, 3.0, Fade(WHITE, 0.90));


 // Game Over Screen Title (duh)
 //
 len   = MeasureTextEx(font1, "GAME  OVER", (font1.baseSize * 4), 1);
 txt_x = (SCREEN_W / 2) - (len.x / 2);

 DrawTextEx(font1, "GAME  OVER", (Vector2){txt_x, 35}, font1.baseSize * 4, 1, WHITE);


 // Score and swing metrics
 //
 txt_x = 226;

 sprintf(custom_text, "TOTAL SCORE      %08d", score);
 DrawTextEx(font1, custom_text, (Vector2){txt_x, 200}, font1.baseSize * 2, 1, SCORE_GREEN);


 // Press 'Z' to continue
 //
 len   = MeasureTextEx(font1, "[ PRESS 'Z' TO CONTINUE ]", (font1.baseSize * 2), 1);
 txt_x = (SCREEN_W / 2) - (len.x / 2);


 pulse = sin(anims[4] * rad_conv) * 0.50;
 DrawTextEx(font1, "[ PRESS 'Z' TO CONTINUE ]", (Vector2){txt_x, SCREEN_H - 65}, font1.baseSize * 2, 1, Fade(WHITE, 0.50 + pulse));

 return;
}






// Draws ghetto-ass tutorial
//
void draw_tutorial()
{
 int txt_x   = 0;
 float pulse = 0.0;
 Vector2 len = { 0, 0 };

 // Draw box texture as background
 //
 Rectangle tex_s = { box_tex_x,box_tex_y, 64, 32 };
 Rectangle tex_d = { 0, 0, SCREEN_W, SCREEN_H };
 DrawTextureTiled(box_tex, tex_s, tex_d, (Vector2){0,0}, 0.0, 3.0, Fade(WHITE, 0.90));


 len   = MeasureTextEx(font1, "INSTRUCTIONS", (font1.baseSize * 4), 1);
 txt_x = (SCREEN_W / 2) - (len.x / 2);

 DrawTextEx(font1, "INSTRUCTIONS", (Vector2){txt_x, 44}, font1.baseSize * 4, 1, WHITE);


 // NOTE: Next project, move this into a routine to clean this janky shit up
 //
 len   = MeasureTextEx(font1, "A DEMON IS TRAPPED IN THE MOON -- AND ABOUT TO BREAK OUT!", (font1.baseSize * 1), 1);
 txt_x = (SCREEN_W / 2) - (len.x / 2);
 DrawTextEx(font1, "A DEMON IS TRAPPED IN THE MOON -- AND ABOUT TO BREAK OUT!", (Vector2){txt_x, 150}, font1.baseSize * 1, 1, WHITE);


 len   = MeasureTextEx(font1, "THE GHOST OF SPIRO AGNEW HAS BEEN CHOSEN TO PROTECT THE WORLD.", (font1.baseSize * 1), 1);
 txt_x = (SCREEN_W / 2) - (len.x / 2);
 DrawTextEx(font1, "THE GHOST OF SPIRO AGNEW HAS BEEN CHOSEN TO PROTECT THE WORLD.", (Vector2){txt_x, 210}, font1.baseSize * 1, 1, WHITE);


 len   = MeasureTextEx(font1, "THE SHRINE LANTERNS ARE THE ONLY THING KEEPING IT IMPRISONED.", (font1.baseSize * 1), 1);
 txt_x = (SCREEN_W / 2) - (len.x / 2);
 DrawTextEx(font1, "THE SHRINE LANTERNS ARE THE ONLY THING KEEPING IT IMPRISONED.", (Vector2){txt_x, 240}, font1.baseSize * 1, 1, WHITE);


 len   = MeasureTextEx(font1, "MOVE SIDE TO SIDE WITH ARROW KEYS. AVOID GETTING HIT!!", (font1.baseSize * 1), 1);
 txt_x = (SCREEN_W / 2) - (len.x / 2);
 DrawTextEx(font1, "MOVE SIDE TO SIDE WITH ARROW KEYS. AVOID GETTING HIT!!", (Vector2){txt_x, 270}, font1.baseSize * 1, 1, WHITE);


 len   = MeasureTextEx(font1, "SHOTS THAT BOUNCE OFF YOU CAN DAMAGE LANTERNS!", (font1.baseSize * 1), 1);
 txt_x = (SCREEN_W / 2) - (len.x / 2);
 DrawTextEx(font1, "SHOTS THAT BOUNCE OFF YOU CAN DAMAGE LANTERNS!", (Vector2){txt_x, 330}, font1.baseSize * 1, 1, WHITE);


 len   = MeasureTextEx(font1, "HOLD [Z] AND PRESS ARROW KEYS TO SELECT A SPIRIT TO SUMMON.", (font1.baseSize * 1), 1);
 txt_x = (SCREEN_W / 2) - (len.x / 2);
 DrawTextEx(font1, "HOLD [Z] AND PRESS ARROW KEYS TO SELECT A SPIRIT TO SUMMON.", (Vector2){txt_x, 360}, font1.baseSize * 1, 1, GREEN);


 len   = MeasureTextEx(font1, "THESE ARE POWERFUL. EXPERIMENT AND SEE WHAT THEY DO.", (font1.baseSize * 1), 1);
 txt_x = (SCREEN_W / 2) - (len.x / 2);
 DrawTextEx(font1, "THESE ARE POWERFUL. EXPERIMENT AND SEE WHAT THEY DO.", (Vector2){txt_x, 390}, font1.baseSize * 1, 1, GREEN);


 len   = MeasureTextEx(font1, "THE GAME ENDS WHEN ALL LANTERNS ARE EXTINGUISHED.", (font1.baseSize * 1), 1);
 txt_x = (SCREEN_W / 2) - (len.x / 2);
 DrawTextEx(font1, "THE GAME ENDS WHEN ALL LANTERNS ARE EXTINGUISHED.", (Vector2){txt_x, 460}, font1.baseSize * 1, 1, WHITE);


 len   = MeasureTextEx(font1, "THEY SAID THERE WAS A MAN IN THE MOON. IT WASN'T A MAN.", (font1.baseSize * 1), 1);
 txt_x = (SCREEN_W / 2) - (len.x / 2);
 DrawTextEx(font1, "THEY SAID THERE WAS A MAN IN THE MOON. IT WASN'T A MAN.", (Vector2){txt_x, 670}, font1.baseSize * 1, 1, YELLOW);




 // Press 'Z' to continue
 //
 len   = MeasureTextEx(font1, "[ PRESS 'Z' TO CONTINUE ]", (font1.baseSize * 2), 1);
 txt_x = (SCREEN_W / 2) - (len.x / 2);

 pulse = sin(anims[4] * rad_conv) * 0.50;
 DrawTextEx(font1, "[ PRESS 'Z' TO CONTINUE ]", (Vector2){txt_x, SCREEN_H - 65}, font1.baseSize * 2, 1, Fade(WHITE, 0.50 + pulse));

 return;
}







// Spawns trail behind baseball that quickly fades out
//
int spawn_trail(int ball)
{
 int who = -1;

 who = spawn_actor(0, actors[ball].pos.x, actors[ball].pos.y - 0.50, actors[ball].pos.z, 2, 0.0, 0.0, 0.0);

 if(who != -1) {
     actors[who].angle   = 0;
     actors[who].team    = 4;
     actors[who].scale   = 2.0;
     actors[who].state   = 4;
     actors[who].cel     = tex_16x;
     actors[who]._size_w = 16;
     actors[who]._size_h = 16;
     actors[who].stamina = 100;
     actors[who].color   = WHITE;
     actors[who].gravity = 0;
     actors[who].enabled = 1;
               }

 return(who);
}









// NOTE: Checks two floats and returns 1 if they are within range
//
int check_floats(float one, float two, float range)
{

 float check = fabs(one - two);

 if(check <= range) { return(1); }

 return(0);
}




// NOTE: Checks against a known actor (puppet, lamp, etc)
//       and returns TRUE if they are within ? units of each other.
//
int check_collision(int who, int target, int radius, int z_adjust)
{

 if(who < 0 || who >= MAX_ACTORS) { printf("ERROR: Who OOB in %s", __func__); return(0); }
 if(target < 0 || target >= MAX_ACTORS) { printf("ERROR: Target OOB in %s", __func__); return(0); }

 int dist = abs(FR_2d_dist(actors[who].pos.x, (actors[who].pos.y - actors[who].pos.z),
                       actors[target].pos.x, (actors[target].pos.y - actors[target].pos.z - z_adjust)));

 if(dist < radius) { return(1); }
 else              { return(0); }
}






void push_rect(Rectangle *rect, float x, float y, float w, float h)
{

 rect->x      = x;
 rect->y      = y;
 rect->width  = w;
 rect->height = h;

 return;
}






int spawn_brush(int x, int y, Color col, float scale)
{
 int who = -1;

 who = spawn_actor(0, 0, 0, 0, 0, 0.0, 0.0, 0.0);

 if(who != -1) {
     actors[who].angle   = 0;
     actors[who].team    = 3;
     actors[who].scale   = scale;
     actors[who].state   = 0;
     actors[who].pos.x   = x;
     actors[who].pos.y   = y;
     actors[who].pos.z   = 0;
     actors[who].effect  = 2;
     actors[who].cel     = tex_brush;
     actors[who]._size_w = 960;
     actors[who]._size_h = 32;
     actors[who].stamina = 1000;
     actors[who].color   = col;
     actors[who].enabled = 1;
               }

 return(who);
}





int spawn_shrine(int x, int y)
{
 int who = -1;

 who = spawn_actor(0, 0, 0, 0, 0, 0.0, 0.0, 0.0);

 if(who != -1) {
     actors[who].angle   = 0;
     actors[who].team    = 3;
     actors[who].scale   = 3.0;
     actors[who].state   = 0;
     actors[who].pos.x   = x;
     actors[who].pos.y   = y;
     actors[who].pos.z   = 0;
     actors[who].effect  = 0;
     actors[who].cel     = tex_shrine;
     actors[who]._size_w = 256;
     actors[who]._size_h = 128;
     actors[who].stamina = 1000;
     actors[who].color   = WHITE;
     actors[who].enabled = 1;
               }

 return(who);
}





int spawn_lantern(int x, int y, int z_offset)
{
 int who   = -1;
 int value = -1;
 // Start with lantern base
 //
 who   = spawn_actor(0, 0, 0, 0, 0, 0.0, 0.0, 0.0);
 value = who;

 if(who != -1) {
     actors[who].angle   = 0;
     actors[who].team    = 1;
     actors[who].scale   = 4.0;
     actors[who].state   = 8;
     actors[who].pos.x   = x;
     actors[who].pos.y   = y;
     actors[who].pos.z   = z_offset;
     actors[who].effect  = 0;
     actors[who].cel     = tex_64x;
     actors[who]._size_w = 64;
     actors[who]._size_h = 64;
     actors[who].stamina = 100;
     actors[who].color   = WHITE;
     actors[who].enabled = 1;
               }


 // Then flickering flame
 //
 who = spawn_actor(0, 0, 0, 0, 1, 0.0, 0.0, 0.0);
 actors[value].moved_up = who;

 if(who != -1) {
     actors[who].angle   = 0;
     actors[who].team    = 3;
     actors[who].scale   = 4.0;
     actors[who].state   = 0;
     actors[who].pos.x   = x;
     actors[who].pos.y   = y + 1;
     actors[who].pos.z   = -4 + z_offset;
     actors[who].effect  = 1; // Wave shader
     actors[who].cel     = tex_32x;
     actors[who]._size_w = 32;
     actors[who]._size_h = 32;
     actors[who].stamina = 1000;
     actors[who].color   = ORANGE;
     actors[who].enabled = 1;
               }


 // Finally, flame sparkle
 //
 who = spawn_actor(0, 0, 0, 0, 0, 0.0, 0.0, 0.0);
 actors[value].moved_down = who;

 if(who != -1) {
     actors[who].angle   = GetRandomValue(0, 360);
     actors[who].team    = 3;
     actors[who].scale   = 0.50;
     actors[who].state   = 0;
     actors[who].flicker = 1; // Flickering
     actors[who].blend   = 0.50;
     actors[who].pos.x   = x;
     actors[who].pos.y   = y + 2;
     actors[who].pos.z   = 34 + z_offset;
     actors[who].effect  = 3;
     actors[who].roll    = 0.32;
     actors[who].cel     = tex_sparkle;
     actors[who]._size_w = 256;
     actors[who]._size_h = 256;
     actors[who].stamina = 1000;
     actors[who].color   = YELLOW;
     actors[who].enabled = 1;
               }

 return(value);
}





// NOTE: Deals [amount] damage to a lantern.
//       If [amount] is -1, lanterm will be reactivated, and fully repaired
//
void damage_lantern(int who, int amount)
{
 if(who < 0 || who >= MAX_ACTORS) { printf("ERROR: Actor OOB in call to %s. Who = %d", __func__, who); return; }

 int flame = -1;
 int light = -1;

 if(amount == -1) { // We're resurrecting a lamp instead
     actors[who].stamina = 100;
     flame = actors[who].moved_up;
     light = actors[who].moved_down;

     if(valid_actor(flame)) { actors[flame].visible = 1; }
     if(valid_actor(light)) { actors[light].visible = 1; }
     return;
                  }

 // Shields are out. Can't damage them
 //
 if(flags.invulnerable) { return; }


 actors[who].stamina -= amount;
 actors[who].extra = 15;

 if(actors[who].stamina <= 0) {
     flame = actors[who].moved_up;
     light = actors[who].moved_down;

     if(valid_actor(flame)) { actors[flame].visible = 0; }
     if(valid_actor(light)) { actors[light].visible = 0; }
                              }

 return;
}









int spawn_ghost(int x, int y, int z)
{
 int who = -1;

 who = spawn_actor(0, 0, 0, 0, 2, 0.0, 0.0, 0.0);

 if(who != -1) {
     actors[who].angle   = 0;
     actors[who].team    = 1;
     actors[who].scale   = 4.0;
     actors[who].state   = 0;
     actors[who].pos.x   = x;
     actors[who].pos.y   = y;
     actors[who].pos.z   = z;
     actors[who].cel     = tex_32x;
     actors[who]._size_w = 32;
     actors[who]._size_h = 32;
     actors[who].stamina = 1000;
     actors[who].color   = WHITE;
     actors[who].enabled = 1;
               }

 return(who);
}




int spawn_moon()
{
 int who = -1;

 who = spawn_actor(0, 0, -200, 0, 0, 0.0, 0.0, 0.0);

 if(who != -1) {
     actors[who].v_angle = 0;
     actors[who].v_speed = 4.0;
     actors[who].v_roll  = 1.0;

     actors[who].visible = 0;
     actors[who].team    = 2;
     actors[who].state   = 6;
     actors[who].pos.z   = 0;
     actors[who].effect  = 0;
     actors[who].color   = WHITE;
     actors[who].enabled = 1;
               }

 return(who);
}




// NOTE: type 0 = standard red bullet
//
int spawn_bullet(float x, float y, float z, int type)
{
 int who = -1;

 who = spawn_actor(0, x, y, z, (3 + type), 0.0, 0.0, 0.0);

 if(who != -1) {
     actors[who].team    = 2;
     actors[who].angle   = 0;
     actors[who].v_angle = 0;
     actors[who].v_speed = 4.0;
     actors[who].v_roll  = -1.0 + ((float)GetRandomValue(0, 2000) / 1000.0);
     actors[who].scale   = 2.0;
     actors[who].state   = 5;
     actors[who].cel     = tex_32x;
     actors[who]._size_w = 32;
     actors[who]._size_h = 32;
     actors[who].stamina = 1000;
     actors[who].color   = WHITE;
     actors[who].enabled = 1;
               }

 return(who);
}




void moon_shot(int slot)
{
 // Sanity checks
 //
 if(slot < 0 || slot >= MAX_OSCILLATORS) { printf("ERROR: Shot oscillator out of range in %s", __func__); return; }

 int k = spawn_bullet(actors[moon].pos.x + 430, actors[moon].pos.y + 880, actors[moon].pos.z + 400, 0);

 if(k < 0 || k >= MAX_ACTORS) { printf("ERROR: Failed to acquire actor for shot in %s", __func__); return; }

 int _s    = oscillators[slot].shot_type;
 int check = 0;

 /// float shot_vars[5][4] = { // cell, roll, speed, etc

 actors[k].cel_x   = (int)shot_vars[_s][0];
 actors[k].v_roll  = shot_vars[_s][1];
 actors[k].v_speed = shot_vars[_s][2];
 actors[k].v_angle = oscillators[slot].angle;
 actors[k].stamina = 300;

 // Check for "drunken" shots
 //
 if(flags.drunken_salvo > 0) {
     check = GetRandomValue(0, 100);
     if(check < 80) { actors[k].v_roll *= 4.0; }
                             }

 if(flags.frozen_salvo > 0) {
     actors[k].cel_x  = 12;
     actors[k].v_roll = 0.0;
     actors[k].roll   = 1.0;
     actors[k].v_speed *= 0.25;
     actors[k].color  = CHILL_CYAN;
     actors[k].stamina *= 2.0;
                            }

 return;
}




// NOTE: Spawns an animated Amiga ball
//
int spawn_shield_ball(int lamp)
{
 int who = -1;

 who = spawn_actor(0, actors[lamp].pos.x, actors[lamp].pos.y + 3.0, actors[lamp].pos.z + 1000, 0, 0.0, 0.0, 0.0);

 if(who != -1) {
     actors[who].team    = 3;
     actors[who].v_angle = 128.0;
     actors[who].v_speed = 4.0;
     actors[who].scale   = 2.0;
     actors[who].state   = 3;
     actors[who].effect  = 8;
     actors[who].stamina = 1000;
     actors[who].color   = WHITE;
     actors[who].enabled = 1;
               }

 return(who);
}




// NOTE: Spawns a Terminal Eidolon
//
int spawn_terminal(float x, float y, float z)
{
 int who = -1;

 who = spawn_actor(0, x, y, z, 0, 0.0, 0.0, 0.0);

 if(who != -1) {
     actors[who].team    = 3;
     actors[who].scale   = 2.0;
     actors[who].state   = 12;
     actors[who].v_angle = 128.0;
     actors[who].cel     = tex_terminal;
     actors[who]._size_w = 512;
     actors[who]._size_h = 400;
     actors[who].stamina = 1000;
     actors[who].color   = WHITE;
     actors[who].enabled = 1;
               }

 return(who);
}




// NOTE: Spawns a Ouroborus Eidolon
//
int spawn_ouroborus(float x, float y, float z)
{
 int who = -1;

 who = spawn_actor(0, x, y, z, 0, 0.0, 0.0, 0.0);

 if(who != -1) {
     actors[who].team    = 3;
     actors[who].scale   = 2.0;
     actors[who].state   = 13;
     actors[who].cel     = tex_ouroborus;
     actors[who]._size_w = 640;
     actors[who]._size_h = 640;
     actors[who].stamina = 1000;
     actors[who].color   = WHITE;
     actors[who].enabled = 1;
               }

 return(who);
}





// NOTE: Spawns a Fire Dragon Eidolon
//
int spawn_dragon(float y, float z, int dir)
{
 int who = -1;

 who = spawn_actor(0, 0, y, z, 0, 0.0, 0.0, 0.0);

 if(who != -1) {
     actors[who].team    = 3;
     actors[who].scale   = 2.0;
     actors[who].state   = 14;
     actors[who].v_speed = 10.0;
     actors[who].cel     = tex_dragon;
     actors[who]._size_w = 512;
     actors[who]._size_h = 512;
     actors[who].stamina = 1000;
     actors[who].color   = WHITE;

     actors[who].extra   = dir;  // Record direction here

     if(!dir) { /// Coming in from left side
         actors[who].pos.x   = -500;
         actors[who].v_angle = 90.0;
              }
     else { /// Right side entrance
         actors[who].pos.x   = SCREEN_W + 500;
         actors[who].v_angle = 270.0;
         actors[who].flip    = 1;
          }

     actors[who].enabled = 1;
               }

 return(who);
}




// NOTE: Spawns a Wind Dragon Eidolon
//
int spawn_wind(float y, float z, int dir)
{
 int who = -1;

 who = spawn_actor(0, 0, y, z, 0, 0.0, 0.0, 0.0);

 if(who != -1) {
     actors[who].team    = 3;
     actors[who].scale   = 2.0;
     actors[who].state   = 15;
     actors[who].v_speed = 7.0;
     actors[who].cel     = tex_wind;
     actors[who]._size_w = 512;
     actors[who]._size_h = 512;
     actors[who].stamina = 1000;
     actors[who].color   = WHITE;

     actors[who].extra   = dir;  // Record direction here

     if(!dir) { /// Coming in from left side
         actors[who].pos.x   = -500;
         actors[who].v_angle = 90.0;
         actors[who].flip    = 1;
              }
     else { /// Right side entrance
         actors[who].pos.x   = SCREEN_W + 500;
         actors[who].v_angle = 270.0;
          }

     actors[who].enabled = 1;
               }

 return(who);
}






// NOTE: Spawns a gout of fire
//       [dir] = 0 for right travel, 1 for left
//
int spawn_fireball(float x, float y, float z, int dir)
{
 int who = -1;
 Color ORANGE_FLAME = (Color){ 255, 100, 0, 255 };

 who = spawn_actor(0, x, y, z, 0, 0.0, 0.0, 0.0);

 if(who != -1) {
     actors[who].team    = 3;
     actors[who].scale   = 3.5 + (float)((float)GetRandomValue(0, 2000) / 1000.0);
     actors[who].state   = 7;
     actors[who].effect  = 4;
     actors[who].flicker = 1;
     actors[who].v_speed = 8.0;
     actors[who].cel     = tex_32x;
     actors[who].cel_x   = 10;
     actors[who]._size_w = 32;
     actors[who]._size_h = 32;
     actors[who].stamina = 200;
     actors[who].color   = ORANGE_FLAME;

     if(!dir) {
         actors[who].pos.x += 200;
         actors[who].v_angle = 100.0 + (float)((float)GetRandomValue(0, 40000) / 1000.0);
              }
     else {
         actors[who].pos.x -= 200;
         actors[who].v_angle = 260.0 - (float)((float)GetRandomValue(0, 40000) / 1000.0);
          }

     actors[who].enabled = 1;
               }

 return(who);
}




// NOTE: Spawns a chill wind. Travels up instead of down. Rolls up as well
//       [dir] = 0 for right travel, 1 for left
//
int spawn_frostball(float x, float y, float z, int dir)
{
 int who = -1;

 who = spawn_actor(0, x, y, z, 0, 0.0, 0.0, 0.0);

 if(who != -1) {
     actors[who].team    = 3;
     actors[who].scale   = 3.5 + (float)((float)GetRandomValue(0, 2000) / 1000.0);
     actors[who].state   = 7;
     actors[who].effect  = 0;
     actors[who].flicker = 1;
     actors[who].v_speed = 6.5;
     actors[who].cel     = tex_32x;
     actors[who].cel_x   = 11;
     actors[who]._size_w = 32;
     actors[who]._size_h = 32;
     actors[who].stamina = 200;
     actors[who].color   = CHILL_CYAN;

     if(!dir) {
         actors[who].roll   = -3.0;
         actors[who].v_roll = -0.50;
         actors[who].pos.x += 500;
         actors[who].pos.z += 200;
         actors[who].v_angle = 80.0 - (float)((float)GetRandomValue(0, 40000) / 1000.0);
              }
     else {
         actors[who].roll   = 3.0;
         actors[who].v_roll = 0.50;
         actors[who].pos.x -= 500;
         actors[who].pos.z += 200;
         actors[who].v_angle = 280.0 + (float)((float)GetRandomValue(0, 40000) / 1000.0);
          }

     actors[who].enabled = 1;
               }

 return(who);
}





// NOTE: Produces a spinning vortex that makes enemy fire "drunk"
//
int spawn_vortex(float x, float y, float z)
{
 int i   = 0;
 int who = -1;

 for(i=0; i<10; i++) {
     who = spawn_actor(0, x, y, z, 0, 0.0, 0.0, 0.0);

     if(who != -1) {
         actors[who].angle   = GetRandomValue(0, 360);
         actors[who].team    = 3;
         actors[who].scale   = 1.0 + (float)((float)GetRandomValue(0, 4000) / 1000.0);
         actors[who].state   = 2;
         actors[who].flicker = 1; // Flickering
         actors[who].effect  = 3;
         actors[who].roll    = -4.0 + (float)((float)GetRandomValue(0, 8000) / 1000.0);
         actors[who].cel     = tex_sparkle;
         actors[who]._size_w = 256;
         actors[who]._size_h = 256;
         actors[who].stamina = 1000;
         actors[who].color   = PURPLE;

         // Variable scale is gonna fuck up the stacking. Adjust Z to compensate
         //
         actors[who].pos.z -= ((256.0 * actors[who].scale) / 2.0);
         actors[who].enabled = 1;
                   }
                     }

 // Check existing shots upon activation
 //
 for(i=0; i<MAX_ACTORS; i++) {
     if(actors[i].state == 5) { actors[i].v_roll *= 4.0; }
                             }

 // Makes enemy shots wonky for a while
 //
 flags.drunken_salvo = 1000;

 return(who);
}





// NOTE: Basic scaling routine
//       Translates source to scaled
//
float scale(float value, float source_min, float source_max, float scaled_min, float scaled_max)
{
 long double percentage = 0;

 if((source_max - source_min) == 0.000) { return(0); } // If used in framework, signal division by zero

 percentage = (value - source_min) / (source_max - source_min);

 return ((percentage * (scaled_max - scaled_min)) + scaled_min);
}





// NOTE: Displays various signals
//       type 0 = WARNING!
//       type 1 = STRIKE
//
void display_signal(int type)
{
 // Set the UI flag and timer accordingly
 // Setting the timer to 2.00 allows for an extra 100 ticks before the signal fades out
 // Raylib doesn't care if you set alpha over 1.00 for fade, it'll clip :D
 //
 show_signal = type;
 anims[9]    = 2.00;

 return;
}




void buffer_sfx(int sfx_slot, int ticks)
{
 int i = 0;

 for(i=0; i<16; i++) {
     if(sfx_buffer[i][0] == -1) {
         sfx_buffer[i][0] = sfx_slot;
         sfx_buffer[i][1] = ticks;
         return;
                                }

                     }

 printf("Couldn't queue sfx. No slots available\n");

 return;
}






Color FR_grab_gradient(Color c1, Color c2, float banding, float zero_to_one)
{

 Color value = BLANK;

 float b_factor;
 float zto = zero_to_one;

 float final_r;
 float final_g;
 float final_b;

 float d_r = c2.r - c1.r;
 float d_g = c2.g - c1.g;
 float d_b = c2.b - c1.b;

 // for(i=0; i<flags.pingpong; i++) { zto = FR_fold_gradient(zto); }

 // There's a weird rounding error this 0.99 fixes. Normally it'd be 1.0
 //
 if(zto >= 1.0) { zto = 0.99; }
 if(zto < 0.0)  { zto = 0.0;  }


 // b_factor comes out a little worse for wear after being
 // folded. Sometimes 13.0000, sometimes 12.99999. Add and round
 // to eliminate this effect.
 //
 if(banding > 1) {
     b_factor = (zto * banding) + 0.01;
     b_factor = floor(b_factor);

     final_r  = c1.r + (d_r / banding) * (float)b_factor;
     final_g  = c1.g + (d_g / banding) * (float)b_factor;
     final_b  = c1.b + (d_b / banding) * (float)b_factor;

     value.r = (int)final_r;
     value.g = (int)final_g;
     value.b = (int)final_b;
     value.a = (int)255;
                 }

 // No banding = smooth gradient
 //
 else {
     final_r = c1.r + (d_r * zto);
     final_g = c1.g + (d_g * zto);
     final_b = c1.b + (d_b * zto);

     value.r = (int)final_r;
     value.g = (int)final_g;
     value.b = (int)final_b;
     value.a = (int)255;
      }

 return(value);
}



// NOTE: Returns TRUE if actor slot is valid
//
bool valid_actor(int who)
{

 if(who >= 0 && who < MAX_ACTORS) { return(1); }
 else                             { return(0); }
}



// NOTE: Performs normalization of floating point values. Returns 0-1
//
float norm_f(float source, float min, float max)
{

 return((source - min) / (max - min));
}
